// Unicode data, built from the Unicode Standard 16.0.0
// Code generated by wcwidth.py, DO NOT EDIT.

#pragma once
#include "data-types.h"

START_ALLOW_CASE_RANGE

typedef enum GraphemeBreakProperty {
	GBP_AtStart,
	GBP_None,
	GBP_Prepend,
	GBP_CR,
	GBP_LF,
	GBP_Control,
	GBP_Extend,
	GBP_Regional_Indicator,
	GBP_SpacingMark,
	GBP_L,
	GBP_V,
	GBP_T,
	GBP_LV,
	GBP_LVT,
	GBP_ZWJ,
} GraphemeBreakProperty;

typedef enum IndicConjunctBreak {
	ICB_None,
	ICB_Linker,
	ICB_Consonant,
	ICB_Extend,
} IndicConjunctBreak;

static inline GraphemeBreakProperty
grapheme_break_property(const char_type c) {
	switch(c) {
		 // Prepend (28 codepoints {{{
		case 0x600 ... 0x605:
			return GBP_Prepend;
		case 0x6dd:
			return GBP_Prepend;
		case 0x70f:
			return GBP_Prepend;
		case 0x890 ... 0x891:
			return GBP_Prepend;
		case 0x8e2:
			return GBP_Prepend;
		case 0xd4e:
			return GBP_Prepend;
		case 0x110bd:
			return GBP_Prepend;
		case 0x110cd:
			return GBP_Prepend;
		case 0x111c2 ... 0x111c3:
			return GBP_Prepend;
		case 0x113d1:
			return GBP_Prepend;
		case 0x1193f:
			return GBP_Prepend;
		case 0x11941:
			return GBP_Prepend;
		case 0x11a3a:
			return GBP_Prepend;
		case 0x11a84 ... 0x11a89:
			return GBP_Prepend;
		case 0x11d46:
			return GBP_Prepend;
		case 0x11f02:
			return GBP_Prepend;
		 // }}}

		 // CR (1 codepoints {{{
		case 0xd:
			return GBP_CR;
		 // }}}

		 // LF (1 codepoints {{{
		case 0xa:
			return GBP_LF;
		 // }}}

		 // Control (3893 codepoints {{{
		case 0x0 ... 0x9:
			return GBP_Control;
		case 0xb ... 0xc:
			return GBP_Control;
		case 0xe ... 0x1f:
			return GBP_Control;
		case 0x7f ... 0x9f:
			return GBP_Control;
		case 0xad:
			return GBP_Control;
		case 0x61c:
			return GBP_Control;
		case 0x180e:
			return GBP_Control;
		case 0x200b:
			return GBP_Control;
		case 0x200e ... 0x200f:
			return GBP_Control;
		case 0x2028 ... 0x202e:
			return GBP_Control;
		case 0x2060 ... 0x206f:
			return GBP_Control;
		case 0xfeff:
			return GBP_Control;
		case 0xfff0 ... 0xfffb:
			return GBP_Control;
		case 0x13430 ... 0x1343f:
			return GBP_Control;
		case 0x1bca0 ... 0x1bca3:
			return GBP_Control;
		case 0x1d173 ... 0x1d17a:
			return GBP_Control;
		case 0xe0000 ... 0xe001f:
			return GBP_Control;
		case 0xe0080 ... 0xe00ff:
			return GBP_Control;
		case 0xe01f0 ... 0xe0fff:
			return GBP_Control;
		 // }}}

		 // Extend (2198 codepoints {{{
		case 0x300 ... 0x36f:
			return GBP_Extend;
		case 0x483 ... 0x489:
			return GBP_Extend;
		case 0x591 ... 0x5bd:
			return GBP_Extend;
		case 0x5bf:
			return GBP_Extend;
		case 0x5c1 ... 0x5c2:
			return GBP_Extend;
		case 0x5c4 ... 0x5c5:
			return GBP_Extend;
		case 0x5c7:
			return GBP_Extend;
		case 0x610 ... 0x61a:
			return GBP_Extend;
		case 0x64b ... 0x65f:
			return GBP_Extend;
		case 0x670:
			return GBP_Extend;
		case 0x6d6 ... 0x6dc:
			return GBP_Extend;
		case 0x6df ... 0x6e4:
			return GBP_Extend;
		case 0x6e7 ... 0x6e8:
			return GBP_Extend;
		case 0x6ea ... 0x6ed:
			return GBP_Extend;
		case 0x711:
			return GBP_Extend;
		case 0x730 ... 0x74a:
			return GBP_Extend;
		case 0x7a6 ... 0x7b0:
			return GBP_Extend;
		case 0x7eb ... 0x7f3:
			return GBP_Extend;
		case 0x7fd:
			return GBP_Extend;
		case 0x816 ... 0x819:
			return GBP_Extend;
		case 0x81b ... 0x823:
			return GBP_Extend;
		case 0x825 ... 0x827:
			return GBP_Extend;
		case 0x829 ... 0x82d:
			return GBP_Extend;
		case 0x859 ... 0x85b:
			return GBP_Extend;
		case 0x897 ... 0x89f:
			return GBP_Extend;
		case 0x8ca ... 0x8e1:
			return GBP_Extend;
		case 0x8e3 ... 0x902:
			return GBP_Extend;
		case 0x93a:
			return GBP_Extend;
		case 0x93c:
			return GBP_Extend;
		case 0x941 ... 0x948:
			return GBP_Extend;
		case 0x94d:
			return GBP_Extend;
		case 0x951 ... 0x957:
			return GBP_Extend;
		case 0x962 ... 0x963:
			return GBP_Extend;
		case 0x981:
			return GBP_Extend;
		case 0x9bc:
			return GBP_Extend;
		case 0x9be:
			return GBP_Extend;
		case 0x9c1 ... 0x9c4:
			return GBP_Extend;
		case 0x9cd:
			return GBP_Extend;
		case 0x9d7:
			return GBP_Extend;
		case 0x9e2 ... 0x9e3:
			return GBP_Extend;
		case 0x9fe:
			return GBP_Extend;
		case 0xa01 ... 0xa02:
			return GBP_Extend;
		case 0xa3c:
			return GBP_Extend;
		case 0xa41 ... 0xa42:
			return GBP_Extend;
		case 0xa47 ... 0xa48:
			return GBP_Extend;
		case 0xa4b ... 0xa4d:
			return GBP_Extend;
		case 0xa51:
			return GBP_Extend;
		case 0xa70 ... 0xa71:
			return GBP_Extend;
		case 0xa75:
			return GBP_Extend;
		case 0xa81 ... 0xa82:
			return GBP_Extend;
		case 0xabc:
			return GBP_Extend;
		case 0xac1 ... 0xac5:
			return GBP_Extend;
		case 0xac7 ... 0xac8:
			return GBP_Extend;
		case 0xacd:
			return GBP_Extend;
		case 0xae2 ... 0xae3:
			return GBP_Extend;
		case 0xafa ... 0xaff:
			return GBP_Extend;
		case 0xb01:
			return GBP_Extend;
		case 0xb3c:
			return GBP_Extend;
		case 0xb3e ... 0xb3f:
			return GBP_Extend;
		case 0xb41 ... 0xb44:
			return GBP_Extend;
		case 0xb4d:
			return GBP_Extend;
		case 0xb55 ... 0xb57:
			return GBP_Extend;
		case 0xb62 ... 0xb63:
			return GBP_Extend;
		case 0xb82:
			return GBP_Extend;
		case 0xbbe:
			return GBP_Extend;
		case 0xbc0:
			return GBP_Extend;
		case 0xbcd:
			return GBP_Extend;
		case 0xbd7:
			return GBP_Extend;
		case 0xc00:
			return GBP_Extend;
		case 0xc04:
			return GBP_Extend;
		case 0xc3c:
			return GBP_Extend;
		case 0xc3e ... 0xc40:
			return GBP_Extend;
		case 0xc46 ... 0xc48:
			return GBP_Extend;
		case 0xc4a ... 0xc4d:
			return GBP_Extend;
		case 0xc55 ... 0xc56:
			return GBP_Extend;
		case 0xc62 ... 0xc63:
			return GBP_Extend;
		case 0xc81:
			return GBP_Extend;
		case 0xcbc:
			return GBP_Extend;
		case 0xcbf ... 0xcc0:
			return GBP_Extend;
		case 0xcc2:
			return GBP_Extend;
		case 0xcc6 ... 0xcc8:
			return GBP_Extend;
		case 0xcca ... 0xccd:
			return GBP_Extend;
		case 0xcd5 ... 0xcd6:
			return GBP_Extend;
		case 0xce2 ... 0xce3:
			return GBP_Extend;
		case 0xd00 ... 0xd01:
			return GBP_Extend;
		case 0xd3b ... 0xd3c:
			return GBP_Extend;
		case 0xd3e:
			return GBP_Extend;
		case 0xd41 ... 0xd44:
			return GBP_Extend;
		case 0xd4d:
			return GBP_Extend;
		case 0xd57:
			return GBP_Extend;
		case 0xd62 ... 0xd63:
			return GBP_Extend;
		case 0xd81:
			return GBP_Extend;
		case 0xdca:
			return GBP_Extend;
		case 0xdcf:
			return GBP_Extend;
		case 0xdd2 ... 0xdd4:
			return GBP_Extend;
		case 0xdd6:
			return GBP_Extend;
		case 0xddf:
			return GBP_Extend;
		case 0xe31:
			return GBP_Extend;
		case 0xe34 ... 0xe3a:
			return GBP_Extend;
		case 0xe47 ... 0xe4e:
			return GBP_Extend;
		case 0xeb1:
			return GBP_Extend;
		case 0xeb4 ... 0xebc:
			return GBP_Extend;
		case 0xec8 ... 0xece:
			return GBP_Extend;
		case 0xf18 ... 0xf19:
			return GBP_Extend;
		case 0xf35:
			return GBP_Extend;
		case 0xf37:
			return GBP_Extend;
		case 0xf39:
			return GBP_Extend;
		case 0xf71 ... 0xf7e:
			return GBP_Extend;
		case 0xf80 ... 0xf84:
			return GBP_Extend;
		case 0xf86 ... 0xf87:
			return GBP_Extend;
		case 0xf8d ... 0xf97:
			return GBP_Extend;
		case 0xf99 ... 0xfbc:
			return GBP_Extend;
		case 0xfc6:
			return GBP_Extend;
		case 0x102d ... 0x1030:
			return GBP_Extend;
		case 0x1032 ... 0x1037:
			return GBP_Extend;
		case 0x1039 ... 0x103a:
			return GBP_Extend;
		case 0x103d ... 0x103e:
			return GBP_Extend;
		case 0x1058 ... 0x1059:
			return GBP_Extend;
		case 0x105e ... 0x1060:
			return GBP_Extend;
		case 0x1071 ... 0x1074:
			return GBP_Extend;
		case 0x1082:
			return GBP_Extend;
		case 0x1085 ... 0x1086:
			return GBP_Extend;
		case 0x108d:
			return GBP_Extend;
		case 0x109d:
			return GBP_Extend;
		case 0x135d ... 0x135f:
			return GBP_Extend;
		case 0x1712 ... 0x1715:
			return GBP_Extend;
		case 0x1732 ... 0x1734:
			return GBP_Extend;
		case 0x1752 ... 0x1753:
			return GBP_Extend;
		case 0x1772 ... 0x1773:
			return GBP_Extend;
		case 0x17b4 ... 0x17b5:
			return GBP_Extend;
		case 0x17b7 ... 0x17bd:
			return GBP_Extend;
		case 0x17c6:
			return GBP_Extend;
		case 0x17c9 ... 0x17d3:
			return GBP_Extend;
		case 0x17dd:
			return GBP_Extend;
		case 0x180b ... 0x180d:
			return GBP_Extend;
		case 0x180f:
			return GBP_Extend;
		case 0x1885 ... 0x1886:
			return GBP_Extend;
		case 0x18a9:
			return GBP_Extend;
		case 0x1920 ... 0x1922:
			return GBP_Extend;
		case 0x1927 ... 0x1928:
			return GBP_Extend;
		case 0x1932:
			return GBP_Extend;
		case 0x1939 ... 0x193b:
			return GBP_Extend;
		case 0x1a17 ... 0x1a18:
			return GBP_Extend;
		case 0x1a1b:
			return GBP_Extend;
		case 0x1a56:
			return GBP_Extend;
		case 0x1a58 ... 0x1a5e:
			return GBP_Extend;
		case 0x1a60:
			return GBP_Extend;
		case 0x1a62:
			return GBP_Extend;
		case 0x1a65 ... 0x1a6c:
			return GBP_Extend;
		case 0x1a73 ... 0x1a7c:
			return GBP_Extend;
		case 0x1a7f:
			return GBP_Extend;
		case 0x1ab0 ... 0x1ace:
			return GBP_Extend;
		case 0x1b00 ... 0x1b03:
			return GBP_Extend;
		case 0x1b34 ... 0x1b3d:
			return GBP_Extend;
		case 0x1b42 ... 0x1b44:
			return GBP_Extend;
		case 0x1b6b ... 0x1b73:
			return GBP_Extend;
		case 0x1b80 ... 0x1b81:
			return GBP_Extend;
		case 0x1ba2 ... 0x1ba5:
			return GBP_Extend;
		case 0x1ba8 ... 0x1bad:
			return GBP_Extend;
		case 0x1be6:
			return GBP_Extend;
		case 0x1be8 ... 0x1be9:
			return GBP_Extend;
		case 0x1bed:
			return GBP_Extend;
		case 0x1bef ... 0x1bf3:
			return GBP_Extend;
		case 0x1c2c ... 0x1c33:
			return GBP_Extend;
		case 0x1c36 ... 0x1c37:
			return GBP_Extend;
		case 0x1cd0 ... 0x1cd2:
			return GBP_Extend;
		case 0x1cd4 ... 0x1ce0:
			return GBP_Extend;
		case 0x1ce2 ... 0x1ce8:
			return GBP_Extend;
		case 0x1ced:
			return GBP_Extend;
		case 0x1cf4:
			return GBP_Extend;
		case 0x1cf8 ... 0x1cf9:
			return GBP_Extend;
		case 0x1dc0 ... 0x1dff:
			return GBP_Extend;
		case 0x200c:
			return GBP_Extend;
		case 0x20d0 ... 0x20f0:
			return GBP_Extend;
		case 0x2cef ... 0x2cf1:
			return GBP_Extend;
		case 0x2d7f:
			return GBP_Extend;
		case 0x2de0 ... 0x2dff:
			return GBP_Extend;
		case 0x302a ... 0x302f:
			return GBP_Extend;
		case 0x3099 ... 0x309a:
			return GBP_Extend;
		case 0xa66f ... 0xa672:
			return GBP_Extend;
		case 0xa674 ... 0xa67d:
			return GBP_Extend;
		case 0xa69e ... 0xa69f:
			return GBP_Extend;
		case 0xa6f0 ... 0xa6f1:
			return GBP_Extend;
		case 0xa802:
			return GBP_Extend;
		case 0xa806:
			return GBP_Extend;
		case 0xa80b:
			return GBP_Extend;
		case 0xa825 ... 0xa826:
			return GBP_Extend;
		case 0xa82c:
			return GBP_Extend;
		case 0xa8c4 ... 0xa8c5:
			return GBP_Extend;
		case 0xa8e0 ... 0xa8f1:
			return GBP_Extend;
		case 0xa8ff:
			return GBP_Extend;
		case 0xa926 ... 0xa92d:
			return GBP_Extend;
		case 0xa947 ... 0xa951:
			return GBP_Extend;
		case 0xa953:
			return GBP_Extend;
		case 0xa980 ... 0xa982:
			return GBP_Extend;
		case 0xa9b3:
			return GBP_Extend;
		case 0xa9b6 ... 0xa9b9:
			return GBP_Extend;
		case 0xa9bc ... 0xa9bd:
			return GBP_Extend;
		case 0xa9c0:
			return GBP_Extend;
		case 0xa9e5:
			return GBP_Extend;
		case 0xaa29 ... 0xaa2e:
			return GBP_Extend;
		case 0xaa31 ... 0xaa32:
			return GBP_Extend;
		case 0xaa35 ... 0xaa36:
			return GBP_Extend;
		case 0xaa43:
			return GBP_Extend;
		case 0xaa4c:
			return GBP_Extend;
		case 0xaa7c:
			return GBP_Extend;
		case 0xaab0:
			return GBP_Extend;
		case 0xaab2 ... 0xaab4:
			return GBP_Extend;
		case 0xaab7 ... 0xaab8:
			return GBP_Extend;
		case 0xaabe ... 0xaabf:
			return GBP_Extend;
		case 0xaac1:
			return GBP_Extend;
		case 0xaaec ... 0xaaed:
			return GBP_Extend;
		case 0xaaf6:
			return GBP_Extend;
		case 0xabe5:
			return GBP_Extend;
		case 0xabe8:
			return GBP_Extend;
		case 0xabed:
			return GBP_Extend;
		case 0xfb1e:
			return GBP_Extend;
		case 0xfe00 ... 0xfe0f:
			return GBP_Extend;
		case 0xfe20 ... 0xfe2f:
			return GBP_Extend;
		case 0xff9e ... 0xff9f:
			return GBP_Extend;
		case 0x101fd:
			return GBP_Extend;
		case 0x102e0:
			return GBP_Extend;
		case 0x10376 ... 0x1037a:
			return GBP_Extend;
		case 0x10a01 ... 0x10a03:
			return GBP_Extend;
		case 0x10a05 ... 0x10a06:
			return GBP_Extend;
		case 0x10a0c ... 0x10a0f:
			return GBP_Extend;
		case 0x10a38 ... 0x10a3a:
			return GBP_Extend;
		case 0x10a3f:
			return GBP_Extend;
		case 0x10ae5 ... 0x10ae6:
			return GBP_Extend;
		case 0x10d24 ... 0x10d27:
			return GBP_Extend;
		case 0x10d69 ... 0x10d6d:
			return GBP_Extend;
		case 0x10eab ... 0x10eac:
			return GBP_Extend;
		case 0x10efc ... 0x10eff:
			return GBP_Extend;
		case 0x10f46 ... 0x10f50:
			return GBP_Extend;
		case 0x10f82 ... 0x10f85:
			return GBP_Extend;
		case 0x11001:
			return GBP_Extend;
		case 0x11038 ... 0x11046:
			return GBP_Extend;
		case 0x11070:
			return GBP_Extend;
		case 0x11073 ... 0x11074:
			return GBP_Extend;
		case 0x1107f ... 0x11081:
			return GBP_Extend;
		case 0x110b3 ... 0x110b6:
			return GBP_Extend;
		case 0x110b9 ... 0x110ba:
			return GBP_Extend;
		case 0x110c2:
			return GBP_Extend;
		case 0x11100 ... 0x11102:
			return GBP_Extend;
		case 0x11127 ... 0x1112b:
			return GBP_Extend;
		case 0x1112d ... 0x11134:
			return GBP_Extend;
		case 0x11173:
			return GBP_Extend;
		case 0x11180 ... 0x11181:
			return GBP_Extend;
		case 0x111b6 ... 0x111be:
			return GBP_Extend;
		case 0x111c0:
			return GBP_Extend;
		case 0x111c9 ... 0x111cc:
			return GBP_Extend;
		case 0x111cf:
			return GBP_Extend;
		case 0x1122f ... 0x11231:
			return GBP_Extend;
		case 0x11234 ... 0x11237:
			return GBP_Extend;
		case 0x1123e:
			return GBP_Extend;
		case 0x11241:
			return GBP_Extend;
		case 0x112df:
			return GBP_Extend;
		case 0x112e3 ... 0x112ea:
			return GBP_Extend;
		case 0x11300 ... 0x11301:
			return GBP_Extend;
		case 0x1133b ... 0x1133c:
			return GBP_Extend;
		case 0x1133e:
			return GBP_Extend;
		case 0x11340:
			return GBP_Extend;
		case 0x1134d:
			return GBP_Extend;
		case 0x11357:
			return GBP_Extend;
		case 0x11366 ... 0x1136c:
			return GBP_Extend;
		case 0x11370 ... 0x11374:
			return GBP_Extend;
		case 0x113b8:
			return GBP_Extend;
		case 0x113bb ... 0x113c0:
			return GBP_Extend;
		case 0x113c2:
			return GBP_Extend;
		case 0x113c5:
			return GBP_Extend;
		case 0x113c7 ... 0x113c9:
			return GBP_Extend;
		case 0x113ce ... 0x113d0:
			return GBP_Extend;
		case 0x113d2:
			return GBP_Extend;
		case 0x113e1 ... 0x113e2:
			return GBP_Extend;
		case 0x11438 ... 0x1143f:
			return GBP_Extend;
		case 0x11442 ... 0x11444:
			return GBP_Extend;
		case 0x11446:
			return GBP_Extend;
		case 0x1145e:
			return GBP_Extend;
		case 0x114b0:
			return GBP_Extend;
		case 0x114b3 ... 0x114b8:
			return GBP_Extend;
		case 0x114ba:
			return GBP_Extend;
		case 0x114bd:
			return GBP_Extend;
		case 0x114bf ... 0x114c0:
			return GBP_Extend;
		case 0x114c2 ... 0x114c3:
			return GBP_Extend;
		case 0x115af:
			return GBP_Extend;
		case 0x115b2 ... 0x115b5:
			return GBP_Extend;
		case 0x115bc ... 0x115bd:
			return GBP_Extend;
		case 0x115bf ... 0x115c0:
			return GBP_Extend;
		case 0x115dc ... 0x115dd:
			return GBP_Extend;
		case 0x11633 ... 0x1163a:
			return GBP_Extend;
		case 0x1163d:
			return GBP_Extend;
		case 0x1163f ... 0x11640:
			return GBP_Extend;
		case 0x116ab:
			return GBP_Extend;
		case 0x116ad:
			return GBP_Extend;
		case 0x116b0 ... 0x116b7:
			return GBP_Extend;
		case 0x1171d:
			return GBP_Extend;
		case 0x1171f:
			return GBP_Extend;
		case 0x11722 ... 0x11725:
			return GBP_Extend;
		case 0x11727 ... 0x1172b:
			return GBP_Extend;
		case 0x1182f ... 0x11837:
			return GBP_Extend;
		case 0x11839 ... 0x1183a:
			return GBP_Extend;
		case 0x11930:
			return GBP_Extend;
		case 0x1193b ... 0x1193e:
			return GBP_Extend;
		case 0x11943:
			return GBP_Extend;
		case 0x119d4 ... 0x119d7:
			return GBP_Extend;
		case 0x119da ... 0x119db:
			return GBP_Extend;
		case 0x119e0:
			return GBP_Extend;
		case 0x11a01 ... 0x11a0a:
			return GBP_Extend;
		case 0x11a33 ... 0x11a38:
			return GBP_Extend;
		case 0x11a3b ... 0x11a3e:
			return GBP_Extend;
		case 0x11a47:
			return GBP_Extend;
		case 0x11a51 ... 0x11a56:
			return GBP_Extend;
		case 0x11a59 ... 0x11a5b:
			return GBP_Extend;
		case 0x11a8a ... 0x11a96:
			return GBP_Extend;
		case 0x11a98 ... 0x11a99:
			return GBP_Extend;
		case 0x11c30 ... 0x11c36:
			return GBP_Extend;
		case 0x11c38 ... 0x11c3d:
			return GBP_Extend;
		case 0x11c3f:
			return GBP_Extend;
		case 0x11c92 ... 0x11ca7:
			return GBP_Extend;
		case 0x11caa ... 0x11cb0:
			return GBP_Extend;
		case 0x11cb2 ... 0x11cb3:
			return GBP_Extend;
		case 0x11cb5 ... 0x11cb6:
			return GBP_Extend;
		case 0x11d31 ... 0x11d36:
			return GBP_Extend;
		case 0x11d3a:
			return GBP_Extend;
		case 0x11d3c ... 0x11d3d:
			return GBP_Extend;
		case 0x11d3f ... 0x11d45:
			return GBP_Extend;
		case 0x11d47:
			return GBP_Extend;
		case 0x11d90 ... 0x11d91:
			return GBP_Extend;
		case 0x11d95:
			return GBP_Extend;
		case 0x11d97:
			return GBP_Extend;
		case 0x11ef3 ... 0x11ef4:
			return GBP_Extend;
		case 0x11f00 ... 0x11f01:
			return GBP_Extend;
		case 0x11f36 ... 0x11f3a:
			return GBP_Extend;
		case 0x11f40 ... 0x11f42:
			return GBP_Extend;
		case 0x11f5a:
			return GBP_Extend;
		case 0x13440:
			return GBP_Extend;
		case 0x13447 ... 0x13455:
			return GBP_Extend;
		case 0x1611e ... 0x16129:
			return GBP_Extend;
		case 0x1612d ... 0x1612f:
			return GBP_Extend;
		case 0x16af0 ... 0x16af4:
			return GBP_Extend;
		case 0x16b30 ... 0x16b36:
			return GBP_Extend;
		case 0x16f4f:
			return GBP_Extend;
		case 0x16f8f ... 0x16f92:
			return GBP_Extend;
		case 0x16fe4:
			return GBP_Extend;
		case 0x16ff0 ... 0x16ff1:
			return GBP_Extend;
		case 0x1bc9d ... 0x1bc9e:
			return GBP_Extend;
		case 0x1cf00 ... 0x1cf2d:
			return GBP_Extend;
		case 0x1cf30 ... 0x1cf46:
			return GBP_Extend;
		case 0x1d165 ... 0x1d169:
			return GBP_Extend;
		case 0x1d16d ... 0x1d172:
			return GBP_Extend;
		case 0x1d17b ... 0x1d182:
			return GBP_Extend;
		case 0x1d185 ... 0x1d18b:
			return GBP_Extend;
		case 0x1d1aa ... 0x1d1ad:
			return GBP_Extend;
		case 0x1d242 ... 0x1d244:
			return GBP_Extend;
		case 0x1da00 ... 0x1da36:
			return GBP_Extend;
		case 0x1da3b ... 0x1da6c:
			return GBP_Extend;
		case 0x1da75:
			return GBP_Extend;
		case 0x1da84:
			return GBP_Extend;
		case 0x1da9b ... 0x1da9f:
			return GBP_Extend;
		case 0x1daa1 ... 0x1daaf:
			return GBP_Extend;
		case 0x1e000 ... 0x1e006:
			return GBP_Extend;
		case 0x1e008 ... 0x1e018:
			return GBP_Extend;
		case 0x1e01b ... 0x1e021:
			return GBP_Extend;
		case 0x1e023 ... 0x1e024:
			return GBP_Extend;
		case 0x1e026 ... 0x1e02a:
			return GBP_Extend;
		case 0x1e08f:
			return GBP_Extend;
		case 0x1e130 ... 0x1e136:
			return GBP_Extend;
		case 0x1e2ae:
			return GBP_Extend;
		case 0x1e2ec ... 0x1e2ef:
			return GBP_Extend;
		case 0x1e4ec ... 0x1e4ef:
			return GBP_Extend;
		case 0x1e5ee ... 0x1e5ef:
			return GBP_Extend;
		case 0x1e8d0 ... 0x1e8d6:
			return GBP_Extend;
		case 0x1e944 ... 0x1e94a:
			return GBP_Extend;
		case 0x1f3fb ... 0x1f3ff:
			return GBP_Extend;
		case 0xe0020 ... 0xe007f:
			return GBP_Extend;
		case 0xe0100 ... 0xe01ef:
			return GBP_Extend;
		 // }}}

		 // Regional_Indicator (26 codepoints {{{
		case 0x1f1e6 ... 0x1f1ff:
			return GBP_Regional_Indicator;
		 // }}}

		 // SpacingMark (378 codepoints {{{
		case 0x903:
			return GBP_SpacingMark;
		case 0x93b:
			return GBP_SpacingMark;
		case 0x93e ... 0x940:
			return GBP_SpacingMark;
		case 0x949 ... 0x94c:
			return GBP_SpacingMark;
		case 0x94e ... 0x94f:
			return GBP_SpacingMark;
		case 0x982 ... 0x983:
			return GBP_SpacingMark;
		case 0x9bf ... 0x9c0:
			return GBP_SpacingMark;
		case 0x9c7 ... 0x9c8:
			return GBP_SpacingMark;
		case 0x9cb ... 0x9cc:
			return GBP_SpacingMark;
		case 0xa03:
			return GBP_SpacingMark;
		case 0xa3e ... 0xa40:
			return GBP_SpacingMark;
		case 0xa83:
			return GBP_SpacingMark;
		case 0xabe ... 0xac0:
			return GBP_SpacingMark;
		case 0xac9:
			return GBP_SpacingMark;
		case 0xacb ... 0xacc:
			return GBP_SpacingMark;
		case 0xb02 ... 0xb03:
			return GBP_SpacingMark;
		case 0xb40:
			return GBP_SpacingMark;
		case 0xb47 ... 0xb48:
			return GBP_SpacingMark;
		case 0xb4b ... 0xb4c:
			return GBP_SpacingMark;
		case 0xbbf:
			return GBP_SpacingMark;
		case 0xbc1 ... 0xbc2:
			return GBP_SpacingMark;
		case 0xbc6 ... 0xbc8:
			return GBP_SpacingMark;
		case 0xbca ... 0xbcc:
			return GBP_SpacingMark;
		case 0xc01 ... 0xc03:
			return GBP_SpacingMark;
		case 0xc41 ... 0xc44:
			return GBP_SpacingMark;
		case 0xc82 ... 0xc83:
			return GBP_SpacingMark;
		case 0xcbe:
			return GBP_SpacingMark;
		case 0xcc1:
			return GBP_SpacingMark;
		case 0xcc3 ... 0xcc4:
			return GBP_SpacingMark;
		case 0xcf3:
			return GBP_SpacingMark;
		case 0xd02 ... 0xd03:
			return GBP_SpacingMark;
		case 0xd3f ... 0xd40:
			return GBP_SpacingMark;
		case 0xd46 ... 0xd48:
			return GBP_SpacingMark;
		case 0xd4a ... 0xd4c:
			return GBP_SpacingMark;
		case 0xd82 ... 0xd83:
			return GBP_SpacingMark;
		case 0xdd0 ... 0xdd1:
			return GBP_SpacingMark;
		case 0xdd8 ... 0xdde:
			return GBP_SpacingMark;
		case 0xdf2 ... 0xdf3:
			return GBP_SpacingMark;
		case 0xe33:
			return GBP_SpacingMark;
		case 0xeb3:
			return GBP_SpacingMark;
		case 0xf3e ... 0xf3f:
			return GBP_SpacingMark;
		case 0xf7f:
			return GBP_SpacingMark;
		case 0x1031:
			return GBP_SpacingMark;
		case 0x103b ... 0x103c:
			return GBP_SpacingMark;
		case 0x1056 ... 0x1057:
			return GBP_SpacingMark;
		case 0x1084:
			return GBP_SpacingMark;
		case 0x17b6:
			return GBP_SpacingMark;
		case 0x17be ... 0x17c5:
			return GBP_SpacingMark;
		case 0x17c7 ... 0x17c8:
			return GBP_SpacingMark;
		case 0x1923 ... 0x1926:
			return GBP_SpacingMark;
		case 0x1929 ... 0x192b:
			return GBP_SpacingMark;
		case 0x1930 ... 0x1931:
			return GBP_SpacingMark;
		case 0x1933 ... 0x1938:
			return GBP_SpacingMark;
		case 0x1a19 ... 0x1a1a:
			return GBP_SpacingMark;
		case 0x1a55:
			return GBP_SpacingMark;
		case 0x1a57:
			return GBP_SpacingMark;
		case 0x1a6d ... 0x1a72:
			return GBP_SpacingMark;
		case 0x1b04:
			return GBP_SpacingMark;
		case 0x1b3e ... 0x1b41:
			return GBP_SpacingMark;
		case 0x1b82:
			return GBP_SpacingMark;
		case 0x1ba1:
			return GBP_SpacingMark;
		case 0x1ba6 ... 0x1ba7:
			return GBP_SpacingMark;
		case 0x1be7:
			return GBP_SpacingMark;
		case 0x1bea ... 0x1bec:
			return GBP_SpacingMark;
		case 0x1bee:
			return GBP_SpacingMark;
		case 0x1c24 ... 0x1c2b:
			return GBP_SpacingMark;
		case 0x1c34 ... 0x1c35:
			return GBP_SpacingMark;
		case 0x1ce1:
			return GBP_SpacingMark;
		case 0x1cf7:
			return GBP_SpacingMark;
		case 0xa823 ... 0xa824:
			return GBP_SpacingMark;
		case 0xa827:
			return GBP_SpacingMark;
		case 0xa880 ... 0xa881:
			return GBP_SpacingMark;
		case 0xa8b4 ... 0xa8c3:
			return GBP_SpacingMark;
		case 0xa952:
			return GBP_SpacingMark;
		case 0xa983:
			return GBP_SpacingMark;
		case 0xa9b4 ... 0xa9b5:
			return GBP_SpacingMark;
		case 0xa9ba ... 0xa9bb:
			return GBP_SpacingMark;
		case 0xa9be ... 0xa9bf:
			return GBP_SpacingMark;
		case 0xaa2f ... 0xaa30:
			return GBP_SpacingMark;
		case 0xaa33 ... 0xaa34:
			return GBP_SpacingMark;
		case 0xaa4d:
			return GBP_SpacingMark;
		case 0xaaeb:
			return GBP_SpacingMark;
		case 0xaaee ... 0xaaef:
			return GBP_SpacingMark;
		case 0xaaf5:
			return GBP_SpacingMark;
		case 0xabe3 ... 0xabe4:
			return GBP_SpacingMark;
		case 0xabe6 ... 0xabe7:
			return GBP_SpacingMark;
		case 0xabe9 ... 0xabea:
			return GBP_SpacingMark;
		case 0xabec:
			return GBP_SpacingMark;
		case 0x11000:
			return GBP_SpacingMark;
		case 0x11002:
			return GBP_SpacingMark;
		case 0x11082:
			return GBP_SpacingMark;
		case 0x110b0 ... 0x110b2:
			return GBP_SpacingMark;
		case 0x110b7 ... 0x110b8:
			return GBP_SpacingMark;
		case 0x1112c:
			return GBP_SpacingMark;
		case 0x11145 ... 0x11146:
			return GBP_SpacingMark;
		case 0x11182:
			return GBP_SpacingMark;
		case 0x111b3 ... 0x111b5:
			return GBP_SpacingMark;
		case 0x111bf:
			return GBP_SpacingMark;
		case 0x111ce:
			return GBP_SpacingMark;
		case 0x1122c ... 0x1122e:
			return GBP_SpacingMark;
		case 0x11232 ... 0x11233:
			return GBP_SpacingMark;
		case 0x112e0 ... 0x112e2:
			return GBP_SpacingMark;
		case 0x11302 ... 0x11303:
			return GBP_SpacingMark;
		case 0x1133f:
			return GBP_SpacingMark;
		case 0x11341 ... 0x11344:
			return GBP_SpacingMark;
		case 0x11347 ... 0x11348:
			return GBP_SpacingMark;
		case 0x1134b ... 0x1134c:
			return GBP_SpacingMark;
		case 0x11362 ... 0x11363:
			return GBP_SpacingMark;
		case 0x113b9 ... 0x113ba:
			return GBP_SpacingMark;
		case 0x113ca:
			return GBP_SpacingMark;
		case 0x113cc ... 0x113cd:
			return GBP_SpacingMark;
		case 0x11435 ... 0x11437:
			return GBP_SpacingMark;
		case 0x11440 ... 0x11441:
			return GBP_SpacingMark;
		case 0x11445:
			return GBP_SpacingMark;
		case 0x114b1 ... 0x114b2:
			return GBP_SpacingMark;
		case 0x114b9:
			return GBP_SpacingMark;
		case 0x114bb ... 0x114bc:
			return GBP_SpacingMark;
		case 0x114be:
			return GBP_SpacingMark;
		case 0x114c1:
			return GBP_SpacingMark;
		case 0x115b0 ... 0x115b1:
			return GBP_SpacingMark;
		case 0x115b8 ... 0x115bb:
			return GBP_SpacingMark;
		case 0x115be:
			return GBP_SpacingMark;
		case 0x11630 ... 0x11632:
			return GBP_SpacingMark;
		case 0x1163b ... 0x1163c:
			return GBP_SpacingMark;
		case 0x1163e:
			return GBP_SpacingMark;
		case 0x116ac:
			return GBP_SpacingMark;
		case 0x116ae ... 0x116af:
			return GBP_SpacingMark;
		case 0x1171e:
			return GBP_SpacingMark;
		case 0x11726:
			return GBP_SpacingMark;
		case 0x1182c ... 0x1182e:
			return GBP_SpacingMark;
		case 0x11838:
			return GBP_SpacingMark;
		case 0x11931 ... 0x11935:
			return GBP_SpacingMark;
		case 0x11937 ... 0x11938:
			return GBP_SpacingMark;
		case 0x11940:
			return GBP_SpacingMark;
		case 0x11942:
			return GBP_SpacingMark;
		case 0x119d1 ... 0x119d3:
			return GBP_SpacingMark;
		case 0x119dc ... 0x119df:
			return GBP_SpacingMark;
		case 0x119e4:
			return GBP_SpacingMark;
		case 0x11a39:
			return GBP_SpacingMark;
		case 0x11a57 ... 0x11a58:
			return GBP_SpacingMark;
		case 0x11a97:
			return GBP_SpacingMark;
		case 0x11c2f:
			return GBP_SpacingMark;
		case 0x11c3e:
			return GBP_SpacingMark;
		case 0x11ca9:
			return GBP_SpacingMark;
		case 0x11cb1:
			return GBP_SpacingMark;
		case 0x11cb4:
			return GBP_SpacingMark;
		case 0x11d8a ... 0x11d8e:
			return GBP_SpacingMark;
		case 0x11d93 ... 0x11d94:
			return GBP_SpacingMark;
		case 0x11d96:
			return GBP_SpacingMark;
		case 0x11ef5 ... 0x11ef6:
			return GBP_SpacingMark;
		case 0x11f03:
			return GBP_SpacingMark;
		case 0x11f34 ... 0x11f35:
			return GBP_SpacingMark;
		case 0x11f3e ... 0x11f3f:
			return GBP_SpacingMark;
		case 0x1612a ... 0x1612c:
			return GBP_SpacingMark;
		case 0x16f51 ... 0x16f87:
			return GBP_SpacingMark;
		 // }}}

		 // L (125 codepoints {{{
		case 0x1100 ... 0x115f:
			return GBP_L;
		case 0xa960 ... 0xa97c:
			return GBP_L;
		 // }}}

		 // V (100 codepoints {{{
		case 0x1160 ... 0x11a7:
			return GBP_V;
		case 0xd7b0 ... 0xd7c6:
			return GBP_V;
		case 0x16d63:
			return GBP_V;
		case 0x16d67 ... 0x16d6a:
			return GBP_V;
		 // }}}

		 // T (137 codepoints {{{
		case 0x11a8 ... 0x11ff:
			return GBP_T;
		case 0xd7cb ... 0xd7fb:
			return GBP_T;
		 // }}}

		 // LV (399 codepoints {{{
		case 0xac00:
			return GBP_LV;
		case 0xac1c:
			return GBP_LV;
		case 0xac38:
			return GBP_LV;
		case 0xac54:
			return GBP_LV;
		case 0xac70:
			return GBP_LV;
		case 0xac8c:
			return GBP_LV;
		case 0xaca8:
			return GBP_LV;
		case 0xacc4:
			return GBP_LV;
		case 0xace0:
			return GBP_LV;
		case 0xacfc:
			return GBP_LV;
		case 0xad18:
			return GBP_LV;
		case 0xad34:
			return GBP_LV;
		case 0xad50:
			return GBP_LV;
		case 0xad6c:
			return GBP_LV;
		case 0xad88:
			return GBP_LV;
		case 0xada4:
			return GBP_LV;
		case 0xadc0:
			return GBP_LV;
		case 0xaddc:
			return GBP_LV;
		case 0xadf8:
			return GBP_LV;
		case 0xae14:
			return GBP_LV;
		case 0xae30:
			return GBP_LV;
		case 0xae4c:
			return GBP_LV;
		case 0xae68:
			return GBP_LV;
		case 0xae84:
			return GBP_LV;
		case 0xaea0:
			return GBP_LV;
		case 0xaebc:
			return GBP_LV;
		case 0xaed8:
			return GBP_LV;
		case 0xaef4:
			return GBP_LV;
		case 0xaf10:
			return GBP_LV;
		case 0xaf2c:
			return GBP_LV;
		case 0xaf48:
			return GBP_LV;
		case 0xaf64:
			return GBP_LV;
		case 0xaf80:
			return GBP_LV;
		case 0xaf9c:
			return GBP_LV;
		case 0xafb8:
			return GBP_LV;
		case 0xafd4:
			return GBP_LV;
		case 0xaff0:
			return GBP_LV;
		case 0xb00c:
			return GBP_LV;
		case 0xb028:
			return GBP_LV;
		case 0xb044:
			return GBP_LV;
		case 0xb060:
			return GBP_LV;
		case 0xb07c:
			return GBP_LV;
		case 0xb098:
			return GBP_LV;
		case 0xb0b4:
			return GBP_LV;
		case 0xb0d0:
			return GBP_LV;
		case 0xb0ec:
			return GBP_LV;
		case 0xb108:
			return GBP_LV;
		case 0xb124:
			return GBP_LV;
		case 0xb140:
			return GBP_LV;
		case 0xb15c:
			return GBP_LV;
		case 0xb178:
			return GBP_LV;
		case 0xb194:
			return GBP_LV;
		case 0xb1b0:
			return GBP_LV;
		case 0xb1cc:
			return GBP_LV;
		case 0xb1e8:
			return GBP_LV;
		case 0xb204:
			return GBP_LV;
		case 0xb220:
			return GBP_LV;
		case 0xb23c:
			return GBP_LV;
		case 0xb258:
			return GBP_LV;
		case 0xb274:
			return GBP_LV;
		case 0xb290:
			return GBP_LV;
		case 0xb2ac:
			return GBP_LV;
		case 0xb2c8:
			return GBP_LV;
		case 0xb2e4:
			return GBP_LV;
		case 0xb300:
			return GBP_LV;
		case 0xb31c:
			return GBP_LV;
		case 0xb338:
			return GBP_LV;
		case 0xb354:
			return GBP_LV;
		case 0xb370:
			return GBP_LV;
		case 0xb38c:
			return GBP_LV;
		case 0xb3a8:
			return GBP_LV;
		case 0xb3c4:
			return GBP_LV;
		case 0xb3e0:
			return GBP_LV;
		case 0xb3fc:
			return GBP_LV;
		case 0xb418:
			return GBP_LV;
		case 0xb434:
			return GBP_LV;
		case 0xb450:
			return GBP_LV;
		case 0xb46c:
			return GBP_LV;
		case 0xb488:
			return GBP_LV;
		case 0xb4a4:
			return GBP_LV;
		case 0xb4c0:
			return GBP_LV;
		case 0xb4dc:
			return GBP_LV;
		case 0xb4f8:
			return GBP_LV;
		case 0xb514:
			return GBP_LV;
		case 0xb530:
			return GBP_LV;
		case 0xb54c:
			return GBP_LV;
		case 0xb568:
			return GBP_LV;
		case 0xb584:
			return GBP_LV;
		case 0xb5a0:
			return GBP_LV;
		case 0xb5bc:
			return GBP_LV;
		case 0xb5d8:
			return GBP_LV;
		case 0xb5f4:
			return GBP_LV;
		case 0xb610:
			return GBP_LV;
		case 0xb62c:
			return GBP_LV;
		case 0xb648:
			return GBP_LV;
		case 0xb664:
			return GBP_LV;
		case 0xb680:
			return GBP_LV;
		case 0xb69c:
			return GBP_LV;
		case 0xb6b8:
			return GBP_LV;
		case 0xb6d4:
			return GBP_LV;
		case 0xb6f0:
			return GBP_LV;
		case 0xb70c:
			return GBP_LV;
		case 0xb728:
			return GBP_LV;
		case 0xb744:
			return GBP_LV;
		case 0xb760:
			return GBP_LV;
		case 0xb77c:
			return GBP_LV;
		case 0xb798:
			return GBP_LV;
		case 0xb7b4:
			return GBP_LV;
		case 0xb7d0:
			return GBP_LV;
		case 0xb7ec:
			return GBP_LV;
		case 0xb808:
			return GBP_LV;
		case 0xb824:
			return GBP_LV;
		case 0xb840:
			return GBP_LV;
		case 0xb85c:
			return GBP_LV;
		case 0xb878:
			return GBP_LV;
		case 0xb894:
			return GBP_LV;
		case 0xb8b0:
			return GBP_LV;
		case 0xb8cc:
			return GBP_LV;
		case 0xb8e8:
			return GBP_LV;
		case 0xb904:
			return GBP_LV;
		case 0xb920:
			return GBP_LV;
		case 0xb93c:
			return GBP_LV;
		case 0xb958:
			return GBP_LV;
		case 0xb974:
			return GBP_LV;
		case 0xb990:
			return GBP_LV;
		case 0xb9ac:
			return GBP_LV;
		case 0xb9c8:
			return GBP_LV;
		case 0xb9e4:
			return GBP_LV;
		case 0xba00:
			return GBP_LV;
		case 0xba1c:
			return GBP_LV;
		case 0xba38:
			return GBP_LV;
		case 0xba54:
			return GBP_LV;
		case 0xba70:
			return GBP_LV;
		case 0xba8c:
			return GBP_LV;
		case 0xbaa8:
			return GBP_LV;
		case 0xbac4:
			return GBP_LV;
		case 0xbae0:
			return GBP_LV;
		case 0xbafc:
			return GBP_LV;
		case 0xbb18:
			return GBP_LV;
		case 0xbb34:
			return GBP_LV;
		case 0xbb50:
			return GBP_LV;
		case 0xbb6c:
			return GBP_LV;
		case 0xbb88:
			return GBP_LV;
		case 0xbba4:
			return GBP_LV;
		case 0xbbc0:
			return GBP_LV;
		case 0xbbdc:
			return GBP_LV;
		case 0xbbf8:
			return GBP_LV;
		case 0xbc14:
			return GBP_LV;
		case 0xbc30:
			return GBP_LV;
		case 0xbc4c:
			return GBP_LV;
		case 0xbc68:
			return GBP_LV;
		case 0xbc84:
			return GBP_LV;
		case 0xbca0:
			return GBP_LV;
		case 0xbcbc:
			return GBP_LV;
		case 0xbcd8:
			return GBP_LV;
		case 0xbcf4:
			return GBP_LV;
		case 0xbd10:
			return GBP_LV;
		case 0xbd2c:
			return GBP_LV;
		case 0xbd48:
			return GBP_LV;
		case 0xbd64:
			return GBP_LV;
		case 0xbd80:
			return GBP_LV;
		case 0xbd9c:
			return GBP_LV;
		case 0xbdb8:
			return GBP_LV;
		case 0xbdd4:
			return GBP_LV;
		case 0xbdf0:
			return GBP_LV;
		case 0xbe0c:
			return GBP_LV;
		case 0xbe28:
			return GBP_LV;
		case 0xbe44:
			return GBP_LV;
		case 0xbe60:
			return GBP_LV;
		case 0xbe7c:
			return GBP_LV;
		case 0xbe98:
			return GBP_LV;
		case 0xbeb4:
			return GBP_LV;
		case 0xbed0:
			return GBP_LV;
		case 0xbeec:
			return GBP_LV;
		case 0xbf08:
			return GBP_LV;
		case 0xbf24:
			return GBP_LV;
		case 0xbf40:
			return GBP_LV;
		case 0xbf5c:
			return GBP_LV;
		case 0xbf78:
			return GBP_LV;
		case 0xbf94:
			return GBP_LV;
		case 0xbfb0:
			return GBP_LV;
		case 0xbfcc:
			return GBP_LV;
		case 0xbfe8:
			return GBP_LV;
		case 0xc004:
			return GBP_LV;
		case 0xc020:
			return GBP_LV;
		case 0xc03c:
			return GBP_LV;
		case 0xc058:
			return GBP_LV;
		case 0xc074:
			return GBP_LV;
		case 0xc090:
			return GBP_LV;
		case 0xc0ac:
			return GBP_LV;
		case 0xc0c8:
			return GBP_LV;
		case 0xc0e4:
			return GBP_LV;
		case 0xc100:
			return GBP_LV;
		case 0xc11c:
			return GBP_LV;
		case 0xc138:
			return GBP_LV;
		case 0xc154:
			return GBP_LV;
		case 0xc170:
			return GBP_LV;
		case 0xc18c:
			return GBP_LV;
		case 0xc1a8:
			return GBP_LV;
		case 0xc1c4:
			return GBP_LV;
		case 0xc1e0:
			return GBP_LV;
		case 0xc1fc:
			return GBP_LV;
		case 0xc218:
			return GBP_LV;
		case 0xc234:
			return GBP_LV;
		case 0xc250:
			return GBP_LV;
		case 0xc26c:
			return GBP_LV;
		case 0xc288:
			return GBP_LV;
		case 0xc2a4:
			return GBP_LV;
		case 0xc2c0:
			return GBP_LV;
		case 0xc2dc:
			return GBP_LV;
		case 0xc2f8:
			return GBP_LV;
		case 0xc314:
			return GBP_LV;
		case 0xc330:
			return GBP_LV;
		case 0xc34c:
			return GBP_LV;
		case 0xc368:
			return GBP_LV;
		case 0xc384:
			return GBP_LV;
		case 0xc3a0:
			return GBP_LV;
		case 0xc3bc:
			return GBP_LV;
		case 0xc3d8:
			return GBP_LV;
		case 0xc3f4:
			return GBP_LV;
		case 0xc410:
			return GBP_LV;
		case 0xc42c:
			return GBP_LV;
		case 0xc448:
			return GBP_LV;
		case 0xc464:
			return GBP_LV;
		case 0xc480:
			return GBP_LV;
		case 0xc49c:
			return GBP_LV;
		case 0xc4b8:
			return GBP_LV;
		case 0xc4d4:
			return GBP_LV;
		case 0xc4f0:
			return GBP_LV;
		case 0xc50c:
			return GBP_LV;
		case 0xc528:
			return GBP_LV;
		case 0xc544:
			return GBP_LV;
		case 0xc560:
			return GBP_LV;
		case 0xc57c:
			return GBP_LV;
		case 0xc598:
			return GBP_LV;
		case 0xc5b4:
			return GBP_LV;
		case 0xc5d0:
			return GBP_LV;
		case 0xc5ec:
			return GBP_LV;
		case 0xc608:
			return GBP_LV;
		case 0xc624:
			return GBP_LV;
		case 0xc640:
			return GBP_LV;
		case 0xc65c:
			return GBP_LV;
		case 0xc678:
			return GBP_LV;
		case 0xc694:
			return GBP_LV;
		case 0xc6b0:
			return GBP_LV;
		case 0xc6cc:
			return GBP_LV;
		case 0xc6e8:
			return GBP_LV;
		case 0xc704:
			return GBP_LV;
		case 0xc720:
			return GBP_LV;
		case 0xc73c:
			return GBP_LV;
		case 0xc758:
			return GBP_LV;
		case 0xc774:
			return GBP_LV;
		case 0xc790:
			return GBP_LV;
		case 0xc7ac:
			return GBP_LV;
		case 0xc7c8:
			return GBP_LV;
		case 0xc7e4:
			return GBP_LV;
		case 0xc800:
			return GBP_LV;
		case 0xc81c:
			return GBP_LV;
		case 0xc838:
			return GBP_LV;
		case 0xc854:
			return GBP_LV;
		case 0xc870:
			return GBP_LV;
		case 0xc88c:
			return GBP_LV;
		case 0xc8a8:
			return GBP_LV;
		case 0xc8c4:
			return GBP_LV;
		case 0xc8e0:
			return GBP_LV;
		case 0xc8fc:
			return GBP_LV;
		case 0xc918:
			return GBP_LV;
		case 0xc934:
			return GBP_LV;
		case 0xc950:
			return GBP_LV;
		case 0xc96c:
			return GBP_LV;
		case 0xc988:
			return GBP_LV;
		case 0xc9a4:
			return GBP_LV;
		case 0xc9c0:
			return GBP_LV;
		case 0xc9dc:
			return GBP_LV;
		case 0xc9f8:
			return GBP_LV;
		case 0xca14:
			return GBP_LV;
		case 0xca30:
			return GBP_LV;
		case 0xca4c:
			return GBP_LV;
		case 0xca68:
			return GBP_LV;
		case 0xca84:
			return GBP_LV;
		case 0xcaa0:
			return GBP_LV;
		case 0xcabc:
			return GBP_LV;
		case 0xcad8:
			return GBP_LV;
		case 0xcaf4:
			return GBP_LV;
		case 0xcb10:
			return GBP_LV;
		case 0xcb2c:
			return GBP_LV;
		case 0xcb48:
			return GBP_LV;
		case 0xcb64:
			return GBP_LV;
		case 0xcb80:
			return GBP_LV;
		case 0xcb9c:
			return GBP_LV;
		case 0xcbb8:
			return GBP_LV;
		case 0xcbd4:
			return GBP_LV;
		case 0xcbf0:
			return GBP_LV;
		case 0xcc0c:
			return GBP_LV;
		case 0xcc28:
			return GBP_LV;
		case 0xcc44:
			return GBP_LV;
		case 0xcc60:
			return GBP_LV;
		case 0xcc7c:
			return GBP_LV;
		case 0xcc98:
			return GBP_LV;
		case 0xccb4:
			return GBP_LV;
		case 0xccd0:
			return GBP_LV;
		case 0xccec:
			return GBP_LV;
		case 0xcd08:
			return GBP_LV;
		case 0xcd24:
			return GBP_LV;
		case 0xcd40:
			return GBP_LV;
		case 0xcd5c:
			return GBP_LV;
		case 0xcd78:
			return GBP_LV;
		case 0xcd94:
			return GBP_LV;
		case 0xcdb0:
			return GBP_LV;
		case 0xcdcc:
			return GBP_LV;
		case 0xcde8:
			return GBP_LV;
		case 0xce04:
			return GBP_LV;
		case 0xce20:
			return GBP_LV;
		case 0xce3c:
			return GBP_LV;
		case 0xce58:
			return GBP_LV;
		case 0xce74:
			return GBP_LV;
		case 0xce90:
			return GBP_LV;
		case 0xceac:
			return GBP_LV;
		case 0xcec8:
			return GBP_LV;
		case 0xcee4:
			return GBP_LV;
		case 0xcf00:
			return GBP_LV;
		case 0xcf1c:
			return GBP_LV;
		case 0xcf38:
			return GBP_LV;
		case 0xcf54:
			return GBP_LV;
		case 0xcf70:
			return GBP_LV;
		case 0xcf8c:
			return GBP_LV;
		case 0xcfa8:
			return GBP_LV;
		case 0xcfc4:
			return GBP_LV;
		case 0xcfe0:
			return GBP_LV;
		case 0xcffc:
			return GBP_LV;
		case 0xd018:
			return GBP_LV;
		case 0xd034:
			return GBP_LV;
		case 0xd050:
			return GBP_LV;
		case 0xd06c:
			return GBP_LV;
		case 0xd088:
			return GBP_LV;
		case 0xd0a4:
			return GBP_LV;
		case 0xd0c0:
			return GBP_LV;
		case 0xd0dc:
			return GBP_LV;
		case 0xd0f8:
			return GBP_LV;
		case 0xd114:
			return GBP_LV;
		case 0xd130:
			return GBP_LV;
		case 0xd14c:
			return GBP_LV;
		case 0xd168:
			return GBP_LV;
		case 0xd184:
			return GBP_LV;
		case 0xd1a0:
			return GBP_LV;
		case 0xd1bc:
			return GBP_LV;
		case 0xd1d8:
			return GBP_LV;
		case 0xd1f4:
			return GBP_LV;
		case 0xd210:
			return GBP_LV;
		case 0xd22c:
			return GBP_LV;
		case 0xd248:
			return GBP_LV;
		case 0xd264:
			return GBP_LV;
		case 0xd280:
			return GBP_LV;
		case 0xd29c:
			return GBP_LV;
		case 0xd2b8:
			return GBP_LV;
		case 0xd2d4:
			return GBP_LV;
		case 0xd2f0:
			return GBP_LV;
		case 0xd30c:
			return GBP_LV;
		case 0xd328:
			return GBP_LV;
		case 0xd344:
			return GBP_LV;
		case 0xd360:
			return GBP_LV;
		case 0xd37c:
			return GBP_LV;
		case 0xd398:
			return GBP_LV;
		case 0xd3b4:
			return GBP_LV;
		case 0xd3d0:
			return GBP_LV;
		case 0xd3ec:
			return GBP_LV;
		case 0xd408:
			return GBP_LV;
		case 0xd424:
			return GBP_LV;
		case 0xd440:
			return GBP_LV;
		case 0xd45c:
			return GBP_LV;
		case 0xd478:
			return GBP_LV;
		case 0xd494:
			return GBP_LV;
		case 0xd4b0:
			return GBP_LV;
		case 0xd4cc:
			return GBP_LV;
		case 0xd4e8:
			return GBP_LV;
		case 0xd504:
			return GBP_LV;
		case 0xd520:
			return GBP_LV;
		case 0xd53c:
			return GBP_LV;
		case 0xd558:
			return GBP_LV;
		case 0xd574:
			return GBP_LV;
		case 0xd590:
			return GBP_LV;
		case 0xd5ac:
			return GBP_LV;
		case 0xd5c8:
			return GBP_LV;
		case 0xd5e4:
			return GBP_LV;
		case 0xd600:
			return GBP_LV;
		case 0xd61c:
			return GBP_LV;
		case 0xd638:
			return GBP_LV;
		case 0xd654:
			return GBP_LV;
		case 0xd670:
			return GBP_LV;
		case 0xd68c:
			return GBP_LV;
		case 0xd6a8:
			return GBP_LV;
		case 0xd6c4:
			return GBP_LV;
		case 0xd6e0:
			return GBP_LV;
		case 0xd6fc:
			return GBP_LV;
		case 0xd718:
			return GBP_LV;
		case 0xd734:
			return GBP_LV;
		case 0xd750:
			return GBP_LV;
		case 0xd76c:
			return GBP_LV;
		case 0xd788:
			return GBP_LV;
		 // }}}

		 // LVT (10773 codepoints {{{
		case 0xac01 ... 0xac1b:
			return GBP_LVT;
		case 0xac1d ... 0xac37:
			return GBP_LVT;
		case 0xac39 ... 0xac53:
			return GBP_LVT;
		case 0xac55 ... 0xac6f:
			return GBP_LVT;
		case 0xac71 ... 0xac8b:
			return GBP_LVT;
		case 0xac8d ... 0xaca7:
			return GBP_LVT;
		case 0xaca9 ... 0xacc3:
			return GBP_LVT;
		case 0xacc5 ... 0xacdf:
			return GBP_LVT;
		case 0xace1 ... 0xacfb:
			return GBP_LVT;
		case 0xacfd ... 0xad17:
			return GBP_LVT;
		case 0xad19 ... 0xad33:
			return GBP_LVT;
		case 0xad35 ... 0xad4f:
			return GBP_LVT;
		case 0xad51 ... 0xad6b:
			return GBP_LVT;
		case 0xad6d ... 0xad87:
			return GBP_LVT;
		case 0xad89 ... 0xada3:
			return GBP_LVT;
		case 0xada5 ... 0xadbf:
			return GBP_LVT;
		case 0xadc1 ... 0xaddb:
			return GBP_LVT;
		case 0xaddd ... 0xadf7:
			return GBP_LVT;
		case 0xadf9 ... 0xae13:
			return GBP_LVT;
		case 0xae15 ... 0xae2f:
			return GBP_LVT;
		case 0xae31 ... 0xae4b:
			return GBP_LVT;
		case 0xae4d ... 0xae67:
			return GBP_LVT;
		case 0xae69 ... 0xae83:
			return GBP_LVT;
		case 0xae85 ... 0xae9f:
			return GBP_LVT;
		case 0xaea1 ... 0xaebb:
			return GBP_LVT;
		case 0xaebd ... 0xaed7:
			return GBP_LVT;
		case 0xaed9 ... 0xaef3:
			return GBP_LVT;
		case 0xaef5 ... 0xaf0f:
			return GBP_LVT;
		case 0xaf11 ... 0xaf2b:
			return GBP_LVT;
		case 0xaf2d ... 0xaf47:
			return GBP_LVT;
		case 0xaf49 ... 0xaf63:
			return GBP_LVT;
		case 0xaf65 ... 0xaf7f:
			return GBP_LVT;
		case 0xaf81 ... 0xaf9b:
			return GBP_LVT;
		case 0xaf9d ... 0xafb7:
			return GBP_LVT;
		case 0xafb9 ... 0xafd3:
			return GBP_LVT;
		case 0xafd5 ... 0xafef:
			return GBP_LVT;
		case 0xaff1 ... 0xb00b:
			return GBP_LVT;
		case 0xb00d ... 0xb027:
			return GBP_LVT;
		case 0xb029 ... 0xb043:
			return GBP_LVT;
		case 0xb045 ... 0xb05f:
			return GBP_LVT;
		case 0xb061 ... 0xb07b:
			return GBP_LVT;
		case 0xb07d ... 0xb097:
			return GBP_LVT;
		case 0xb099 ... 0xb0b3:
			return GBP_LVT;
		case 0xb0b5 ... 0xb0cf:
			return GBP_LVT;
		case 0xb0d1 ... 0xb0eb:
			return GBP_LVT;
		case 0xb0ed ... 0xb107:
			return GBP_LVT;
		case 0xb109 ... 0xb123:
			return GBP_LVT;
		case 0xb125 ... 0xb13f:
			return GBP_LVT;
		case 0xb141 ... 0xb15b:
			return GBP_LVT;
		case 0xb15d ... 0xb177:
			return GBP_LVT;
		case 0xb179 ... 0xb193:
			return GBP_LVT;
		case 0xb195 ... 0xb1af:
			return GBP_LVT;
		case 0xb1b1 ... 0xb1cb:
			return GBP_LVT;
		case 0xb1cd ... 0xb1e7:
			return GBP_LVT;
		case 0xb1e9 ... 0xb203:
			return GBP_LVT;
		case 0xb205 ... 0xb21f:
			return GBP_LVT;
		case 0xb221 ... 0xb23b:
			return GBP_LVT;
		case 0xb23d ... 0xb257:
			return GBP_LVT;
		case 0xb259 ... 0xb273:
			return GBP_LVT;
		case 0xb275 ... 0xb28f:
			return GBP_LVT;
		case 0xb291 ... 0xb2ab:
			return GBP_LVT;
		case 0xb2ad ... 0xb2c7:
			return GBP_LVT;
		case 0xb2c9 ... 0xb2e3:
			return GBP_LVT;
		case 0xb2e5 ... 0xb2ff:
			return GBP_LVT;
		case 0xb301 ... 0xb31b:
			return GBP_LVT;
		case 0xb31d ... 0xb337:
			return GBP_LVT;
		case 0xb339 ... 0xb353:
			return GBP_LVT;
		case 0xb355 ... 0xb36f:
			return GBP_LVT;
		case 0xb371 ... 0xb38b:
			return GBP_LVT;
		case 0xb38d ... 0xb3a7:
			return GBP_LVT;
		case 0xb3a9 ... 0xb3c3:
			return GBP_LVT;
		case 0xb3c5 ... 0xb3df:
			return GBP_LVT;
		case 0xb3e1 ... 0xb3fb:
			return GBP_LVT;
		case 0xb3fd ... 0xb417:
			return GBP_LVT;
		case 0xb419 ... 0xb433:
			return GBP_LVT;
		case 0xb435 ... 0xb44f:
			return GBP_LVT;
		case 0xb451 ... 0xb46b:
			return GBP_LVT;
		case 0xb46d ... 0xb487:
			return GBP_LVT;
		case 0xb489 ... 0xb4a3:
			return GBP_LVT;
		case 0xb4a5 ... 0xb4bf:
			return GBP_LVT;
		case 0xb4c1 ... 0xb4db:
			return GBP_LVT;
		case 0xb4dd ... 0xb4f7:
			return GBP_LVT;
		case 0xb4f9 ... 0xb513:
			return GBP_LVT;
		case 0xb515 ... 0xb52f:
			return GBP_LVT;
		case 0xb531 ... 0xb54b:
			return GBP_LVT;
		case 0xb54d ... 0xb567:
			return GBP_LVT;
		case 0xb569 ... 0xb583:
			return GBP_LVT;
		case 0xb585 ... 0xb59f:
			return GBP_LVT;
		case 0xb5a1 ... 0xb5bb:
			return GBP_LVT;
		case 0xb5bd ... 0xb5d7:
			return GBP_LVT;
		case 0xb5d9 ... 0xb5f3:
			return GBP_LVT;
		case 0xb5f5 ... 0xb60f:
			return GBP_LVT;
		case 0xb611 ... 0xb62b:
			return GBP_LVT;
		case 0xb62d ... 0xb647:
			return GBP_LVT;
		case 0xb649 ... 0xb663:
			return GBP_LVT;
		case 0xb665 ... 0xb67f:
			return GBP_LVT;
		case 0xb681 ... 0xb69b:
			return GBP_LVT;
		case 0xb69d ... 0xb6b7:
			return GBP_LVT;
		case 0xb6b9 ... 0xb6d3:
			return GBP_LVT;
		case 0xb6d5 ... 0xb6ef:
			return GBP_LVT;
		case 0xb6f1 ... 0xb70b:
			return GBP_LVT;
		case 0xb70d ... 0xb727:
			return GBP_LVT;
		case 0xb729 ... 0xb743:
			return GBP_LVT;
		case 0xb745 ... 0xb75f:
			return GBP_LVT;
		case 0xb761 ... 0xb77b:
			return GBP_LVT;
		case 0xb77d ... 0xb797:
			return GBP_LVT;
		case 0xb799 ... 0xb7b3:
			return GBP_LVT;
		case 0xb7b5 ... 0xb7cf:
			return GBP_LVT;
		case 0xb7d1 ... 0xb7eb:
			return GBP_LVT;
		case 0xb7ed ... 0xb807:
			return GBP_LVT;
		case 0xb809 ... 0xb823:
			return GBP_LVT;
		case 0xb825 ... 0xb83f:
			return GBP_LVT;
		case 0xb841 ... 0xb85b:
			return GBP_LVT;
		case 0xb85d ... 0xb877:
			return GBP_LVT;
		case 0xb879 ... 0xb893:
			return GBP_LVT;
		case 0xb895 ... 0xb8af:
			return GBP_LVT;
		case 0xb8b1 ... 0xb8cb:
			return GBP_LVT;
		case 0xb8cd ... 0xb8e7:
			return GBP_LVT;
		case 0xb8e9 ... 0xb903:
			return GBP_LVT;
		case 0xb905 ... 0xb91f:
			return GBP_LVT;
		case 0xb921 ... 0xb93b:
			return GBP_LVT;
		case 0xb93d ... 0xb957:
			return GBP_LVT;
		case 0xb959 ... 0xb973:
			return GBP_LVT;
		case 0xb975 ... 0xb98f:
			return GBP_LVT;
		case 0xb991 ... 0xb9ab:
			return GBP_LVT;
		case 0xb9ad ... 0xb9c7:
			return GBP_LVT;
		case 0xb9c9 ... 0xb9e3:
			return GBP_LVT;
		case 0xb9e5 ... 0xb9ff:
			return GBP_LVT;
		case 0xba01 ... 0xba1b:
			return GBP_LVT;
		case 0xba1d ... 0xba37:
			return GBP_LVT;
		case 0xba39 ... 0xba53:
			return GBP_LVT;
		case 0xba55 ... 0xba6f:
			return GBP_LVT;
		case 0xba71 ... 0xba8b:
			return GBP_LVT;
		case 0xba8d ... 0xbaa7:
			return GBP_LVT;
		case 0xbaa9 ... 0xbac3:
			return GBP_LVT;
		case 0xbac5 ... 0xbadf:
			return GBP_LVT;
		case 0xbae1 ... 0xbafb:
			return GBP_LVT;
		case 0xbafd ... 0xbb17:
			return GBP_LVT;
		case 0xbb19 ... 0xbb33:
			return GBP_LVT;
		case 0xbb35 ... 0xbb4f:
			return GBP_LVT;
		case 0xbb51 ... 0xbb6b:
			return GBP_LVT;
		case 0xbb6d ... 0xbb87:
			return GBP_LVT;
		case 0xbb89 ... 0xbba3:
			return GBP_LVT;
		case 0xbba5 ... 0xbbbf:
			return GBP_LVT;
		case 0xbbc1 ... 0xbbdb:
			return GBP_LVT;
		case 0xbbdd ... 0xbbf7:
			return GBP_LVT;
		case 0xbbf9 ... 0xbc13:
			return GBP_LVT;
		case 0xbc15 ... 0xbc2f:
			return GBP_LVT;
		case 0xbc31 ... 0xbc4b:
			return GBP_LVT;
		case 0xbc4d ... 0xbc67:
			return GBP_LVT;
		case 0xbc69 ... 0xbc83:
			return GBP_LVT;
		case 0xbc85 ... 0xbc9f:
			return GBP_LVT;
		case 0xbca1 ... 0xbcbb:
			return GBP_LVT;
		case 0xbcbd ... 0xbcd7:
			return GBP_LVT;
		case 0xbcd9 ... 0xbcf3:
			return GBP_LVT;
		case 0xbcf5 ... 0xbd0f:
			return GBP_LVT;
		case 0xbd11 ... 0xbd2b:
			return GBP_LVT;
		case 0xbd2d ... 0xbd47:
			return GBP_LVT;
		case 0xbd49 ... 0xbd63:
			return GBP_LVT;
		case 0xbd65 ... 0xbd7f:
			return GBP_LVT;
		case 0xbd81 ... 0xbd9b:
			return GBP_LVT;
		case 0xbd9d ... 0xbdb7:
			return GBP_LVT;
		case 0xbdb9 ... 0xbdd3:
			return GBP_LVT;
		case 0xbdd5 ... 0xbdef:
			return GBP_LVT;
		case 0xbdf1 ... 0xbe0b:
			return GBP_LVT;
		case 0xbe0d ... 0xbe27:
			return GBP_LVT;
		case 0xbe29 ... 0xbe43:
			return GBP_LVT;
		case 0xbe45 ... 0xbe5f:
			return GBP_LVT;
		case 0xbe61 ... 0xbe7b:
			return GBP_LVT;
		case 0xbe7d ... 0xbe97:
			return GBP_LVT;
		case 0xbe99 ... 0xbeb3:
			return GBP_LVT;
		case 0xbeb5 ... 0xbecf:
			return GBP_LVT;
		case 0xbed1 ... 0xbeeb:
			return GBP_LVT;
		case 0xbeed ... 0xbf07:
			return GBP_LVT;
		case 0xbf09 ... 0xbf23:
			return GBP_LVT;
		case 0xbf25 ... 0xbf3f:
			return GBP_LVT;
		case 0xbf41 ... 0xbf5b:
			return GBP_LVT;
		case 0xbf5d ... 0xbf77:
			return GBP_LVT;
		case 0xbf79 ... 0xbf93:
			return GBP_LVT;
		case 0xbf95 ... 0xbfaf:
			return GBP_LVT;
		case 0xbfb1 ... 0xbfcb:
			return GBP_LVT;
		case 0xbfcd ... 0xbfe7:
			return GBP_LVT;
		case 0xbfe9 ... 0xc003:
			return GBP_LVT;
		case 0xc005 ... 0xc01f:
			return GBP_LVT;
		case 0xc021 ... 0xc03b:
			return GBP_LVT;
		case 0xc03d ... 0xc057:
			return GBP_LVT;
		case 0xc059 ... 0xc073:
			return GBP_LVT;
		case 0xc075 ... 0xc08f:
			return GBP_LVT;
		case 0xc091 ... 0xc0ab:
			return GBP_LVT;
		case 0xc0ad ... 0xc0c7:
			return GBP_LVT;
		case 0xc0c9 ... 0xc0e3:
			return GBP_LVT;
		case 0xc0e5 ... 0xc0ff:
			return GBP_LVT;
		case 0xc101 ... 0xc11b:
			return GBP_LVT;
		case 0xc11d ... 0xc137:
			return GBP_LVT;
		case 0xc139 ... 0xc153:
			return GBP_LVT;
		case 0xc155 ... 0xc16f:
			return GBP_LVT;
		case 0xc171 ... 0xc18b:
			return GBP_LVT;
		case 0xc18d ... 0xc1a7:
			return GBP_LVT;
		case 0xc1a9 ... 0xc1c3:
			return GBP_LVT;
		case 0xc1c5 ... 0xc1df:
			return GBP_LVT;
		case 0xc1e1 ... 0xc1fb:
			return GBP_LVT;
		case 0xc1fd ... 0xc217:
			return GBP_LVT;
		case 0xc219 ... 0xc233:
			return GBP_LVT;
		case 0xc235 ... 0xc24f:
			return GBP_LVT;
		case 0xc251 ... 0xc26b:
			return GBP_LVT;
		case 0xc26d ... 0xc287:
			return GBP_LVT;
		case 0xc289 ... 0xc2a3:
			return GBP_LVT;
		case 0xc2a5 ... 0xc2bf:
			return GBP_LVT;
		case 0xc2c1 ... 0xc2db:
			return GBP_LVT;
		case 0xc2dd ... 0xc2f7:
			return GBP_LVT;
		case 0xc2f9 ... 0xc313:
			return GBP_LVT;
		case 0xc315 ... 0xc32f:
			return GBP_LVT;
		case 0xc331 ... 0xc34b:
			return GBP_LVT;
		case 0xc34d ... 0xc367:
			return GBP_LVT;
		case 0xc369 ... 0xc383:
			return GBP_LVT;
		case 0xc385 ... 0xc39f:
			return GBP_LVT;
		case 0xc3a1 ... 0xc3bb:
			return GBP_LVT;
		case 0xc3bd ... 0xc3d7:
			return GBP_LVT;
		case 0xc3d9 ... 0xc3f3:
			return GBP_LVT;
		case 0xc3f5 ... 0xc40f:
			return GBP_LVT;
		case 0xc411 ... 0xc42b:
			return GBP_LVT;
		case 0xc42d ... 0xc447:
			return GBP_LVT;
		case 0xc449 ... 0xc463:
			return GBP_LVT;
		case 0xc465 ... 0xc47f:
			return GBP_LVT;
		case 0xc481 ... 0xc49b:
			return GBP_LVT;
		case 0xc49d ... 0xc4b7:
			return GBP_LVT;
		case 0xc4b9 ... 0xc4d3:
			return GBP_LVT;
		case 0xc4d5 ... 0xc4ef:
			return GBP_LVT;
		case 0xc4f1 ... 0xc50b:
			return GBP_LVT;
		case 0xc50d ... 0xc527:
			return GBP_LVT;
		case 0xc529 ... 0xc543:
			return GBP_LVT;
		case 0xc545 ... 0xc55f:
			return GBP_LVT;
		case 0xc561 ... 0xc57b:
			return GBP_LVT;
		case 0xc57d ... 0xc597:
			return GBP_LVT;
		case 0xc599 ... 0xc5b3:
			return GBP_LVT;
		case 0xc5b5 ... 0xc5cf:
			return GBP_LVT;
		case 0xc5d1 ... 0xc5eb:
			return GBP_LVT;
		case 0xc5ed ... 0xc607:
			return GBP_LVT;
		case 0xc609 ... 0xc623:
			return GBP_LVT;
		case 0xc625 ... 0xc63f:
			return GBP_LVT;
		case 0xc641 ... 0xc65b:
			return GBP_LVT;
		case 0xc65d ... 0xc677:
			return GBP_LVT;
		case 0xc679 ... 0xc693:
			return GBP_LVT;
		case 0xc695 ... 0xc6af:
			return GBP_LVT;
		case 0xc6b1 ... 0xc6cb:
			return GBP_LVT;
		case 0xc6cd ... 0xc6e7:
			return GBP_LVT;
		case 0xc6e9 ... 0xc703:
			return GBP_LVT;
		case 0xc705 ... 0xc71f:
			return GBP_LVT;
		case 0xc721 ... 0xc73b:
			return GBP_LVT;
		case 0xc73d ... 0xc757:
			return GBP_LVT;
		case 0xc759 ... 0xc773:
			return GBP_LVT;
		case 0xc775 ... 0xc78f:
			return GBP_LVT;
		case 0xc791 ... 0xc7ab:
			return GBP_LVT;
		case 0xc7ad ... 0xc7c7:
			return GBP_LVT;
		case 0xc7c9 ... 0xc7e3:
			return GBP_LVT;
		case 0xc7e5 ... 0xc7ff:
			return GBP_LVT;
		case 0xc801 ... 0xc81b:
			return GBP_LVT;
		case 0xc81d ... 0xc837:
			return GBP_LVT;
		case 0xc839 ... 0xc853:
			return GBP_LVT;
		case 0xc855 ... 0xc86f:
			return GBP_LVT;
		case 0xc871 ... 0xc88b:
			return GBP_LVT;
		case 0xc88d ... 0xc8a7:
			return GBP_LVT;
		case 0xc8a9 ... 0xc8c3:
			return GBP_LVT;
		case 0xc8c5 ... 0xc8df:
			return GBP_LVT;
		case 0xc8e1 ... 0xc8fb:
			return GBP_LVT;
		case 0xc8fd ... 0xc917:
			return GBP_LVT;
		case 0xc919 ... 0xc933:
			return GBP_LVT;
		case 0xc935 ... 0xc94f:
			return GBP_LVT;
		case 0xc951 ... 0xc96b:
			return GBP_LVT;
		case 0xc96d ... 0xc987:
			return GBP_LVT;
		case 0xc989 ... 0xc9a3:
			return GBP_LVT;
		case 0xc9a5 ... 0xc9bf:
			return GBP_LVT;
		case 0xc9c1 ... 0xc9db:
			return GBP_LVT;
		case 0xc9dd ... 0xc9f7:
			return GBP_LVT;
		case 0xc9f9 ... 0xca13:
			return GBP_LVT;
		case 0xca15 ... 0xca2f:
			return GBP_LVT;
		case 0xca31 ... 0xca4b:
			return GBP_LVT;
		case 0xca4d ... 0xca67:
			return GBP_LVT;
		case 0xca69 ... 0xca83:
			return GBP_LVT;
		case 0xca85 ... 0xca9f:
			return GBP_LVT;
		case 0xcaa1 ... 0xcabb:
			return GBP_LVT;
		case 0xcabd ... 0xcad7:
			return GBP_LVT;
		case 0xcad9 ... 0xcaf3:
			return GBP_LVT;
		case 0xcaf5 ... 0xcb0f:
			return GBP_LVT;
		case 0xcb11 ... 0xcb2b:
			return GBP_LVT;
		case 0xcb2d ... 0xcb47:
			return GBP_LVT;
		case 0xcb49 ... 0xcb63:
			return GBP_LVT;
		case 0xcb65 ... 0xcb7f:
			return GBP_LVT;
		case 0xcb81 ... 0xcb9b:
			return GBP_LVT;
		case 0xcb9d ... 0xcbb7:
			return GBP_LVT;
		case 0xcbb9 ... 0xcbd3:
			return GBP_LVT;
		case 0xcbd5 ... 0xcbef:
			return GBP_LVT;
		case 0xcbf1 ... 0xcc0b:
			return GBP_LVT;
		case 0xcc0d ... 0xcc27:
			return GBP_LVT;
		case 0xcc29 ... 0xcc43:
			return GBP_LVT;
		case 0xcc45 ... 0xcc5f:
			return GBP_LVT;
		case 0xcc61 ... 0xcc7b:
			return GBP_LVT;
		case 0xcc7d ... 0xcc97:
			return GBP_LVT;
		case 0xcc99 ... 0xccb3:
			return GBP_LVT;
		case 0xccb5 ... 0xcccf:
			return GBP_LVT;
		case 0xccd1 ... 0xcceb:
			return GBP_LVT;
		case 0xcced ... 0xcd07:
			return GBP_LVT;
		case 0xcd09 ... 0xcd23:
			return GBP_LVT;
		case 0xcd25 ... 0xcd3f:
			return GBP_LVT;
		case 0xcd41 ... 0xcd5b:
			return GBP_LVT;
		case 0xcd5d ... 0xcd77:
			return GBP_LVT;
		case 0xcd79 ... 0xcd93:
			return GBP_LVT;
		case 0xcd95 ... 0xcdaf:
			return GBP_LVT;
		case 0xcdb1 ... 0xcdcb:
			return GBP_LVT;
		case 0xcdcd ... 0xcde7:
			return GBP_LVT;
		case 0xcde9 ... 0xce03:
			return GBP_LVT;
		case 0xce05 ... 0xce1f:
			return GBP_LVT;
		case 0xce21 ... 0xce3b:
			return GBP_LVT;
		case 0xce3d ... 0xce57:
			return GBP_LVT;
		case 0xce59 ... 0xce73:
			return GBP_LVT;
		case 0xce75 ... 0xce8f:
			return GBP_LVT;
		case 0xce91 ... 0xceab:
			return GBP_LVT;
		case 0xcead ... 0xcec7:
			return GBP_LVT;
		case 0xcec9 ... 0xcee3:
			return GBP_LVT;
		case 0xcee5 ... 0xceff:
			return GBP_LVT;
		case 0xcf01 ... 0xcf1b:
			return GBP_LVT;
		case 0xcf1d ... 0xcf37:
			return GBP_LVT;
		case 0xcf39 ... 0xcf53:
			return GBP_LVT;
		case 0xcf55 ... 0xcf6f:
			return GBP_LVT;
		case 0xcf71 ... 0xcf8b:
			return GBP_LVT;
		case 0xcf8d ... 0xcfa7:
			return GBP_LVT;
		case 0xcfa9 ... 0xcfc3:
			return GBP_LVT;
		case 0xcfc5 ... 0xcfdf:
			return GBP_LVT;
		case 0xcfe1 ... 0xcffb:
			return GBP_LVT;
		case 0xcffd ... 0xd017:
			return GBP_LVT;
		case 0xd019 ... 0xd033:
			return GBP_LVT;
		case 0xd035 ... 0xd04f:
			return GBP_LVT;
		case 0xd051 ... 0xd06b:
			return GBP_LVT;
		case 0xd06d ... 0xd087:
			return GBP_LVT;
		case 0xd089 ... 0xd0a3:
			return GBP_LVT;
		case 0xd0a5 ... 0xd0bf:
			return GBP_LVT;
		case 0xd0c1 ... 0xd0db:
			return GBP_LVT;
		case 0xd0dd ... 0xd0f7:
			return GBP_LVT;
		case 0xd0f9 ... 0xd113:
			return GBP_LVT;
		case 0xd115 ... 0xd12f:
			return GBP_LVT;
		case 0xd131 ... 0xd14b:
			return GBP_LVT;
		case 0xd14d ... 0xd167:
			return GBP_LVT;
		case 0xd169 ... 0xd183:
			return GBP_LVT;
		case 0xd185 ... 0xd19f:
			return GBP_LVT;
		case 0xd1a1 ... 0xd1bb:
			return GBP_LVT;
		case 0xd1bd ... 0xd1d7:
			return GBP_LVT;
		case 0xd1d9 ... 0xd1f3:
			return GBP_LVT;
		case 0xd1f5 ... 0xd20f:
			return GBP_LVT;
		case 0xd211 ... 0xd22b:
			return GBP_LVT;
		case 0xd22d ... 0xd247:
			return GBP_LVT;
		case 0xd249 ... 0xd263:
			return GBP_LVT;
		case 0xd265 ... 0xd27f:
			return GBP_LVT;
		case 0xd281 ... 0xd29b:
			return GBP_LVT;
		case 0xd29d ... 0xd2b7:
			return GBP_LVT;
		case 0xd2b9 ... 0xd2d3:
			return GBP_LVT;
		case 0xd2d5 ... 0xd2ef:
			return GBP_LVT;
		case 0xd2f1 ... 0xd30b:
			return GBP_LVT;
		case 0xd30d ... 0xd327:
			return GBP_LVT;
		case 0xd329 ... 0xd343:
			return GBP_LVT;
		case 0xd345 ... 0xd35f:
			return GBP_LVT;
		case 0xd361 ... 0xd37b:
			return GBP_LVT;
		case 0xd37d ... 0xd397:
			return GBP_LVT;
		case 0xd399 ... 0xd3b3:
			return GBP_LVT;
		case 0xd3b5 ... 0xd3cf:
			return GBP_LVT;
		case 0xd3d1 ... 0xd3eb:
			return GBP_LVT;
		case 0xd3ed ... 0xd407:
			return GBP_LVT;
		case 0xd409 ... 0xd423:
			return GBP_LVT;
		case 0xd425 ... 0xd43f:
			return GBP_LVT;
		case 0xd441 ... 0xd45b:
			return GBP_LVT;
		case 0xd45d ... 0xd477:
			return GBP_LVT;
		case 0xd479 ... 0xd493:
			return GBP_LVT;
		case 0xd495 ... 0xd4af:
			return GBP_LVT;
		case 0xd4b1 ... 0xd4cb:
			return GBP_LVT;
		case 0xd4cd ... 0xd4e7:
			return GBP_LVT;
		case 0xd4e9 ... 0xd503:
			return GBP_LVT;
		case 0xd505 ... 0xd51f:
			return GBP_LVT;
		case 0xd521 ... 0xd53b:
			return GBP_LVT;
		case 0xd53d ... 0xd557:
			return GBP_LVT;
		case 0xd559 ... 0xd573:
			return GBP_LVT;
		case 0xd575 ... 0xd58f:
			return GBP_LVT;
		case 0xd591 ... 0xd5ab:
			return GBP_LVT;
		case 0xd5ad ... 0xd5c7:
			return GBP_LVT;
		case 0xd5c9 ... 0xd5e3:
			return GBP_LVT;
		case 0xd5e5 ... 0xd5ff:
			return GBP_LVT;
		case 0xd601 ... 0xd61b:
			return GBP_LVT;
		case 0xd61d ... 0xd637:
			return GBP_LVT;
		case 0xd639 ... 0xd653:
			return GBP_LVT;
		case 0xd655 ... 0xd66f:
			return GBP_LVT;
		case 0xd671 ... 0xd68b:
			return GBP_LVT;
		case 0xd68d ... 0xd6a7:
			return GBP_LVT;
		case 0xd6a9 ... 0xd6c3:
			return GBP_LVT;
		case 0xd6c5 ... 0xd6df:
			return GBP_LVT;
		case 0xd6e1 ... 0xd6fb:
			return GBP_LVT;
		case 0xd6fd ... 0xd717:
			return GBP_LVT;
		case 0xd719 ... 0xd733:
			return GBP_LVT;
		case 0xd735 ... 0xd74f:
			return GBP_LVT;
		case 0xd751 ... 0xd76b:
			return GBP_LVT;
		case 0xd76d ... 0xd787:
			return GBP_LVT;
		case 0xd789 ... 0xd7a3:
			return GBP_LVT;
		 // }}}

		 // ZWJ (1 codepoints {{{
		case 0x200d:
			return GBP_ZWJ;
		 // }}}

	}
	return GBP_None;
}

static inline IndicConjunctBreak
indic_conjunct_break(const char_type c) {
	switch(c) {
		 // Linker (6 codepoints {{{
		case 0x94d:
			return ICB_Linker;
		case 0x9cd:
			return ICB_Linker;
		case 0xacd:
			return ICB_Linker;
		case 0xb4d:
			return ICB_Linker;
		case 0xc4d:
			return ICB_Linker;
		case 0xd4d:
			return ICB_Linker;
		 // }}}

		 // Consonant (240 codepoints {{{
		case 0x915 ... 0x939:
			return ICB_Consonant;
		case 0x958 ... 0x95f:
			return ICB_Consonant;
		case 0x978 ... 0x97f:
			return ICB_Consonant;
		case 0x995 ... 0x9a8:
			return ICB_Consonant;
		case 0x9aa ... 0x9b0:
			return ICB_Consonant;
		case 0x9b2:
			return ICB_Consonant;
		case 0x9b6 ... 0x9b9:
			return ICB_Consonant;
		case 0x9dc ... 0x9dd:
			return ICB_Consonant;
		case 0x9df:
			return ICB_Consonant;
		case 0x9f0 ... 0x9f1:
			return ICB_Consonant;
		case 0xa95 ... 0xaa8:
			return ICB_Consonant;
		case 0xaaa ... 0xab0:
			return ICB_Consonant;
		case 0xab2 ... 0xab3:
			return ICB_Consonant;
		case 0xab5 ... 0xab9:
			return ICB_Consonant;
		case 0xaf9:
			return ICB_Consonant;
		case 0xb15 ... 0xb28:
			return ICB_Consonant;
		case 0xb2a ... 0xb30:
			return ICB_Consonant;
		case 0xb32 ... 0xb33:
			return ICB_Consonant;
		case 0xb35 ... 0xb39:
			return ICB_Consonant;
		case 0xb5c ... 0xb5d:
			return ICB_Consonant;
		case 0xb5f:
			return ICB_Consonant;
		case 0xb71:
			return ICB_Consonant;
		case 0xc15 ... 0xc28:
			return ICB_Consonant;
		case 0xc2a ... 0xc39:
			return ICB_Consonant;
		case 0xc58 ... 0xc5a:
			return ICB_Consonant;
		case 0xd15 ... 0xd3a:
			return ICB_Consonant;
		 // }}}

		 // Extend (2192 codepoints {{{
		case 0x300 ... 0x36f:
			return ICB_Extend;
		case 0x483 ... 0x489:
			return ICB_Extend;
		case 0x591 ... 0x5bd:
			return ICB_Extend;
		case 0x5bf:
			return ICB_Extend;
		case 0x5c1 ... 0x5c2:
			return ICB_Extend;
		case 0x5c4 ... 0x5c5:
			return ICB_Extend;
		case 0x5c7:
			return ICB_Extend;
		case 0x610 ... 0x61a:
			return ICB_Extend;
		case 0x64b ... 0x65f:
			return ICB_Extend;
		case 0x670:
			return ICB_Extend;
		case 0x6d6 ... 0x6dc:
			return ICB_Extend;
		case 0x6df ... 0x6e4:
			return ICB_Extend;
		case 0x6e7 ... 0x6e8:
			return ICB_Extend;
		case 0x6ea ... 0x6ed:
			return ICB_Extend;
		case 0x711:
			return ICB_Extend;
		case 0x730 ... 0x74a:
			return ICB_Extend;
		case 0x7a6 ... 0x7b0:
			return ICB_Extend;
		case 0x7eb ... 0x7f3:
			return ICB_Extend;
		case 0x7fd:
			return ICB_Extend;
		case 0x816 ... 0x819:
			return ICB_Extend;
		case 0x81b ... 0x823:
			return ICB_Extend;
		case 0x825 ... 0x827:
			return ICB_Extend;
		case 0x829 ... 0x82d:
			return ICB_Extend;
		case 0x859 ... 0x85b:
			return ICB_Extend;
		case 0x897 ... 0x89f:
			return ICB_Extend;
		case 0x8ca ... 0x8e1:
			return ICB_Extend;
		case 0x8e3 ... 0x902:
			return ICB_Extend;
		case 0x93a:
			return ICB_Extend;
		case 0x93c:
			return ICB_Extend;
		case 0x941 ... 0x948:
			return ICB_Extend;
		case 0x951 ... 0x957:
			return ICB_Extend;
		case 0x962 ... 0x963:
			return ICB_Extend;
		case 0x981:
			return ICB_Extend;
		case 0x9bc:
			return ICB_Extend;
		case 0x9be:
			return ICB_Extend;
		case 0x9c1 ... 0x9c4:
			return ICB_Extend;
		case 0x9d7:
			return ICB_Extend;
		case 0x9e2 ... 0x9e3:
			return ICB_Extend;
		case 0x9fe:
			return ICB_Extend;
		case 0xa01 ... 0xa02:
			return ICB_Extend;
		case 0xa3c:
			return ICB_Extend;
		case 0xa41 ... 0xa42:
			return ICB_Extend;
		case 0xa47 ... 0xa48:
			return ICB_Extend;
		case 0xa4b ... 0xa4d:
			return ICB_Extend;
		case 0xa51:
			return ICB_Extend;
		case 0xa70 ... 0xa71:
			return ICB_Extend;
		case 0xa75:
			return ICB_Extend;
		case 0xa81 ... 0xa82:
			return ICB_Extend;
		case 0xabc:
			return ICB_Extend;
		case 0xac1 ... 0xac5:
			return ICB_Extend;
		case 0xac7 ... 0xac8:
			return ICB_Extend;
		case 0xae2 ... 0xae3:
			return ICB_Extend;
		case 0xafa ... 0xaff:
			return ICB_Extend;
		case 0xb01:
			return ICB_Extend;
		case 0xb3c:
			return ICB_Extend;
		case 0xb3e ... 0xb3f:
			return ICB_Extend;
		case 0xb41 ... 0xb44:
			return ICB_Extend;
		case 0xb55 ... 0xb57:
			return ICB_Extend;
		case 0xb62 ... 0xb63:
			return ICB_Extend;
		case 0xb82:
			return ICB_Extend;
		case 0xbbe:
			return ICB_Extend;
		case 0xbc0:
			return ICB_Extend;
		case 0xbcd:
			return ICB_Extend;
		case 0xbd7:
			return ICB_Extend;
		case 0xc00:
			return ICB_Extend;
		case 0xc04:
			return ICB_Extend;
		case 0xc3c:
			return ICB_Extend;
		case 0xc3e ... 0xc40:
			return ICB_Extend;
		case 0xc46 ... 0xc48:
			return ICB_Extend;
		case 0xc4a ... 0xc4c:
			return ICB_Extend;
		case 0xc55 ... 0xc56:
			return ICB_Extend;
		case 0xc62 ... 0xc63:
			return ICB_Extend;
		case 0xc81:
			return ICB_Extend;
		case 0xcbc:
			return ICB_Extend;
		case 0xcbf ... 0xcc0:
			return ICB_Extend;
		case 0xcc2:
			return ICB_Extend;
		case 0xcc6 ... 0xcc8:
			return ICB_Extend;
		case 0xcca ... 0xccd:
			return ICB_Extend;
		case 0xcd5 ... 0xcd6:
			return ICB_Extend;
		case 0xce2 ... 0xce3:
			return ICB_Extend;
		case 0xd00 ... 0xd01:
			return ICB_Extend;
		case 0xd3b ... 0xd3c:
			return ICB_Extend;
		case 0xd3e:
			return ICB_Extend;
		case 0xd41 ... 0xd44:
			return ICB_Extend;
		case 0xd57:
			return ICB_Extend;
		case 0xd62 ... 0xd63:
			return ICB_Extend;
		case 0xd81:
			return ICB_Extend;
		case 0xdca:
			return ICB_Extend;
		case 0xdcf:
			return ICB_Extend;
		case 0xdd2 ... 0xdd4:
			return ICB_Extend;
		case 0xdd6:
			return ICB_Extend;
		case 0xddf:
			return ICB_Extend;
		case 0xe31:
			return ICB_Extend;
		case 0xe34 ... 0xe3a:
			return ICB_Extend;
		case 0xe47 ... 0xe4e:
			return ICB_Extend;
		case 0xeb1:
			return ICB_Extend;
		case 0xeb4 ... 0xebc:
			return ICB_Extend;
		case 0xec8 ... 0xece:
			return ICB_Extend;
		case 0xf18 ... 0xf19:
			return ICB_Extend;
		case 0xf35:
			return ICB_Extend;
		case 0xf37:
			return ICB_Extend;
		case 0xf39:
			return ICB_Extend;
		case 0xf71 ... 0xf7e:
			return ICB_Extend;
		case 0xf80 ... 0xf84:
			return ICB_Extend;
		case 0xf86 ... 0xf87:
			return ICB_Extend;
		case 0xf8d ... 0xf97:
			return ICB_Extend;
		case 0xf99 ... 0xfbc:
			return ICB_Extend;
		case 0xfc6:
			return ICB_Extend;
		case 0x102d ... 0x1030:
			return ICB_Extend;
		case 0x1032 ... 0x1037:
			return ICB_Extend;
		case 0x1039 ... 0x103a:
			return ICB_Extend;
		case 0x103d ... 0x103e:
			return ICB_Extend;
		case 0x1058 ... 0x1059:
			return ICB_Extend;
		case 0x105e ... 0x1060:
			return ICB_Extend;
		case 0x1071 ... 0x1074:
			return ICB_Extend;
		case 0x1082:
			return ICB_Extend;
		case 0x1085 ... 0x1086:
			return ICB_Extend;
		case 0x108d:
			return ICB_Extend;
		case 0x109d:
			return ICB_Extend;
		case 0x135d ... 0x135f:
			return ICB_Extend;
		case 0x1712 ... 0x1715:
			return ICB_Extend;
		case 0x1732 ... 0x1734:
			return ICB_Extend;
		case 0x1752 ... 0x1753:
			return ICB_Extend;
		case 0x1772 ... 0x1773:
			return ICB_Extend;
		case 0x17b4 ... 0x17b5:
			return ICB_Extend;
		case 0x17b7 ... 0x17bd:
			return ICB_Extend;
		case 0x17c6:
			return ICB_Extend;
		case 0x17c9 ... 0x17d3:
			return ICB_Extend;
		case 0x17dd:
			return ICB_Extend;
		case 0x180b ... 0x180d:
			return ICB_Extend;
		case 0x180f:
			return ICB_Extend;
		case 0x1885 ... 0x1886:
			return ICB_Extend;
		case 0x18a9:
			return ICB_Extend;
		case 0x1920 ... 0x1922:
			return ICB_Extend;
		case 0x1927 ... 0x1928:
			return ICB_Extend;
		case 0x1932:
			return ICB_Extend;
		case 0x1939 ... 0x193b:
			return ICB_Extend;
		case 0x1a17 ... 0x1a18:
			return ICB_Extend;
		case 0x1a1b:
			return ICB_Extend;
		case 0x1a56:
			return ICB_Extend;
		case 0x1a58 ... 0x1a5e:
			return ICB_Extend;
		case 0x1a60:
			return ICB_Extend;
		case 0x1a62:
			return ICB_Extend;
		case 0x1a65 ... 0x1a6c:
			return ICB_Extend;
		case 0x1a73 ... 0x1a7c:
			return ICB_Extend;
		case 0x1a7f:
			return ICB_Extend;
		case 0x1ab0 ... 0x1ace:
			return ICB_Extend;
		case 0x1b00 ... 0x1b03:
			return ICB_Extend;
		case 0x1b34 ... 0x1b3d:
			return ICB_Extend;
		case 0x1b42 ... 0x1b44:
			return ICB_Extend;
		case 0x1b6b ... 0x1b73:
			return ICB_Extend;
		case 0x1b80 ... 0x1b81:
			return ICB_Extend;
		case 0x1ba2 ... 0x1ba5:
			return ICB_Extend;
		case 0x1ba8 ... 0x1bad:
			return ICB_Extend;
		case 0x1be6:
			return ICB_Extend;
		case 0x1be8 ... 0x1be9:
			return ICB_Extend;
		case 0x1bed:
			return ICB_Extend;
		case 0x1bef ... 0x1bf3:
			return ICB_Extend;
		case 0x1c2c ... 0x1c33:
			return ICB_Extend;
		case 0x1c36 ... 0x1c37:
			return ICB_Extend;
		case 0x1cd0 ... 0x1cd2:
			return ICB_Extend;
		case 0x1cd4 ... 0x1ce0:
			return ICB_Extend;
		case 0x1ce2 ... 0x1ce8:
			return ICB_Extend;
		case 0x1ced:
			return ICB_Extend;
		case 0x1cf4:
			return ICB_Extend;
		case 0x1cf8 ... 0x1cf9:
			return ICB_Extend;
		case 0x1dc0 ... 0x1dff:
			return ICB_Extend;
		case 0x200d:
			return ICB_Extend;
		case 0x20d0 ... 0x20f0:
			return ICB_Extend;
		case 0x2cef ... 0x2cf1:
			return ICB_Extend;
		case 0x2d7f:
			return ICB_Extend;
		case 0x2de0 ... 0x2dff:
			return ICB_Extend;
		case 0x302a ... 0x302f:
			return ICB_Extend;
		case 0x3099 ... 0x309a:
			return ICB_Extend;
		case 0xa66f ... 0xa672:
			return ICB_Extend;
		case 0xa674 ... 0xa67d:
			return ICB_Extend;
		case 0xa69e ... 0xa69f:
			return ICB_Extend;
		case 0xa6f0 ... 0xa6f1:
			return ICB_Extend;
		case 0xa802:
			return ICB_Extend;
		case 0xa806:
			return ICB_Extend;
		case 0xa80b:
			return ICB_Extend;
		case 0xa825 ... 0xa826:
			return ICB_Extend;
		case 0xa82c:
			return ICB_Extend;
		case 0xa8c4 ... 0xa8c5:
			return ICB_Extend;
		case 0xa8e0 ... 0xa8f1:
			return ICB_Extend;
		case 0xa8ff:
			return ICB_Extend;
		case 0xa926 ... 0xa92d:
			return ICB_Extend;
		case 0xa947 ... 0xa951:
			return ICB_Extend;
		case 0xa953:
			return ICB_Extend;
		case 0xa980 ... 0xa982:
			return ICB_Extend;
		case 0xa9b3:
			return ICB_Extend;
		case 0xa9b6 ... 0xa9b9:
			return ICB_Extend;
		case 0xa9bc ... 0xa9bd:
			return ICB_Extend;
		case 0xa9c0:
			return ICB_Extend;
		case 0xa9e5:
			return ICB_Extend;
		case 0xaa29 ... 0xaa2e:
			return ICB_Extend;
		case 0xaa31 ... 0xaa32:
			return ICB_Extend;
		case 0xaa35 ... 0xaa36:
			return ICB_Extend;
		case 0xaa43:
			return ICB_Extend;
		case 0xaa4c:
			return ICB_Extend;
		case 0xaa7c:
			return ICB_Extend;
		case 0xaab0:
			return ICB_Extend;
		case 0xaab2 ... 0xaab4:
			return ICB_Extend;
		case 0xaab7 ... 0xaab8:
			return ICB_Extend;
		case 0xaabe ... 0xaabf:
			return ICB_Extend;
		case 0xaac1:
			return ICB_Extend;
		case 0xaaec ... 0xaaed:
			return ICB_Extend;
		case 0xaaf6:
			return ICB_Extend;
		case 0xabe5:
			return ICB_Extend;
		case 0xabe8:
			return ICB_Extend;
		case 0xabed:
			return ICB_Extend;
		case 0xfb1e:
			return ICB_Extend;
		case 0xfe00 ... 0xfe0f:
			return ICB_Extend;
		case 0xfe20 ... 0xfe2f:
			return ICB_Extend;
		case 0xff9e ... 0xff9f:
			return ICB_Extend;
		case 0x101fd:
			return ICB_Extend;
		case 0x102e0:
			return ICB_Extend;
		case 0x10376 ... 0x1037a:
			return ICB_Extend;
		case 0x10a01 ... 0x10a03:
			return ICB_Extend;
		case 0x10a05 ... 0x10a06:
			return ICB_Extend;
		case 0x10a0c ... 0x10a0f:
			return ICB_Extend;
		case 0x10a38 ... 0x10a3a:
			return ICB_Extend;
		case 0x10a3f:
			return ICB_Extend;
		case 0x10ae5 ... 0x10ae6:
			return ICB_Extend;
		case 0x10d24 ... 0x10d27:
			return ICB_Extend;
		case 0x10d69 ... 0x10d6d:
			return ICB_Extend;
		case 0x10eab ... 0x10eac:
			return ICB_Extend;
		case 0x10efc ... 0x10eff:
			return ICB_Extend;
		case 0x10f46 ... 0x10f50:
			return ICB_Extend;
		case 0x10f82 ... 0x10f85:
			return ICB_Extend;
		case 0x11001:
			return ICB_Extend;
		case 0x11038 ... 0x11046:
			return ICB_Extend;
		case 0x11070:
			return ICB_Extend;
		case 0x11073 ... 0x11074:
			return ICB_Extend;
		case 0x1107f ... 0x11081:
			return ICB_Extend;
		case 0x110b3 ... 0x110b6:
			return ICB_Extend;
		case 0x110b9 ... 0x110ba:
			return ICB_Extend;
		case 0x110c2:
			return ICB_Extend;
		case 0x11100 ... 0x11102:
			return ICB_Extend;
		case 0x11127 ... 0x1112b:
			return ICB_Extend;
		case 0x1112d ... 0x11134:
			return ICB_Extend;
		case 0x11173:
			return ICB_Extend;
		case 0x11180 ... 0x11181:
			return ICB_Extend;
		case 0x111b6 ... 0x111be:
			return ICB_Extend;
		case 0x111c0:
			return ICB_Extend;
		case 0x111c9 ... 0x111cc:
			return ICB_Extend;
		case 0x111cf:
			return ICB_Extend;
		case 0x1122f ... 0x11231:
			return ICB_Extend;
		case 0x11234 ... 0x11237:
			return ICB_Extend;
		case 0x1123e:
			return ICB_Extend;
		case 0x11241:
			return ICB_Extend;
		case 0x112df:
			return ICB_Extend;
		case 0x112e3 ... 0x112ea:
			return ICB_Extend;
		case 0x11300 ... 0x11301:
			return ICB_Extend;
		case 0x1133b ... 0x1133c:
			return ICB_Extend;
		case 0x1133e:
			return ICB_Extend;
		case 0x11340:
			return ICB_Extend;
		case 0x1134d:
			return ICB_Extend;
		case 0x11357:
			return ICB_Extend;
		case 0x11366 ... 0x1136c:
			return ICB_Extend;
		case 0x11370 ... 0x11374:
			return ICB_Extend;
		case 0x113b8:
			return ICB_Extend;
		case 0x113bb ... 0x113c0:
			return ICB_Extend;
		case 0x113c2:
			return ICB_Extend;
		case 0x113c5:
			return ICB_Extend;
		case 0x113c7 ... 0x113c9:
			return ICB_Extend;
		case 0x113ce ... 0x113d0:
			return ICB_Extend;
		case 0x113d2:
			return ICB_Extend;
		case 0x113e1 ... 0x113e2:
			return ICB_Extend;
		case 0x11438 ... 0x1143f:
			return ICB_Extend;
		case 0x11442 ... 0x11444:
			return ICB_Extend;
		case 0x11446:
			return ICB_Extend;
		case 0x1145e:
			return ICB_Extend;
		case 0x114b0:
			return ICB_Extend;
		case 0x114b3 ... 0x114b8:
			return ICB_Extend;
		case 0x114ba:
			return ICB_Extend;
		case 0x114bd:
			return ICB_Extend;
		case 0x114bf ... 0x114c0:
			return ICB_Extend;
		case 0x114c2 ... 0x114c3:
			return ICB_Extend;
		case 0x115af:
			return ICB_Extend;
		case 0x115b2 ... 0x115b5:
			return ICB_Extend;
		case 0x115bc ... 0x115bd:
			return ICB_Extend;
		case 0x115bf ... 0x115c0:
			return ICB_Extend;
		case 0x115dc ... 0x115dd:
			return ICB_Extend;
		case 0x11633 ... 0x1163a:
			return ICB_Extend;
		case 0x1163d:
			return ICB_Extend;
		case 0x1163f ... 0x11640:
			return ICB_Extend;
		case 0x116ab:
			return ICB_Extend;
		case 0x116ad:
			return ICB_Extend;
		case 0x116b0 ... 0x116b7:
			return ICB_Extend;
		case 0x1171d:
			return ICB_Extend;
		case 0x1171f:
			return ICB_Extend;
		case 0x11722 ... 0x11725:
			return ICB_Extend;
		case 0x11727 ... 0x1172b:
			return ICB_Extend;
		case 0x1182f ... 0x11837:
			return ICB_Extend;
		case 0x11839 ... 0x1183a:
			return ICB_Extend;
		case 0x11930:
			return ICB_Extend;
		case 0x1193b ... 0x1193e:
			return ICB_Extend;
		case 0x11943:
			return ICB_Extend;
		case 0x119d4 ... 0x119d7:
			return ICB_Extend;
		case 0x119da ... 0x119db:
			return ICB_Extend;
		case 0x119e0:
			return ICB_Extend;
		case 0x11a01 ... 0x11a0a:
			return ICB_Extend;
		case 0x11a33 ... 0x11a38:
			return ICB_Extend;
		case 0x11a3b ... 0x11a3e:
			return ICB_Extend;
		case 0x11a47:
			return ICB_Extend;
		case 0x11a51 ... 0x11a56:
			return ICB_Extend;
		case 0x11a59 ... 0x11a5b:
			return ICB_Extend;
		case 0x11a8a ... 0x11a96:
			return ICB_Extend;
		case 0x11a98 ... 0x11a99:
			return ICB_Extend;
		case 0x11c30 ... 0x11c36:
			return ICB_Extend;
		case 0x11c38 ... 0x11c3d:
			return ICB_Extend;
		case 0x11c3f:
			return ICB_Extend;
		case 0x11c92 ... 0x11ca7:
			return ICB_Extend;
		case 0x11caa ... 0x11cb0:
			return ICB_Extend;
		case 0x11cb2 ... 0x11cb3:
			return ICB_Extend;
		case 0x11cb5 ... 0x11cb6:
			return ICB_Extend;
		case 0x11d31 ... 0x11d36:
			return ICB_Extend;
		case 0x11d3a:
			return ICB_Extend;
		case 0x11d3c ... 0x11d3d:
			return ICB_Extend;
		case 0x11d3f ... 0x11d45:
			return ICB_Extend;
		case 0x11d47:
			return ICB_Extend;
		case 0x11d90 ... 0x11d91:
			return ICB_Extend;
		case 0x11d95:
			return ICB_Extend;
		case 0x11d97:
			return ICB_Extend;
		case 0x11ef3 ... 0x11ef4:
			return ICB_Extend;
		case 0x11f00 ... 0x11f01:
			return ICB_Extend;
		case 0x11f36 ... 0x11f3a:
			return ICB_Extend;
		case 0x11f40 ... 0x11f42:
			return ICB_Extend;
		case 0x11f5a:
			return ICB_Extend;
		case 0x13440:
			return ICB_Extend;
		case 0x13447 ... 0x13455:
			return ICB_Extend;
		case 0x1611e ... 0x16129:
			return ICB_Extend;
		case 0x1612d ... 0x1612f:
			return ICB_Extend;
		case 0x16af0 ... 0x16af4:
			return ICB_Extend;
		case 0x16b30 ... 0x16b36:
			return ICB_Extend;
		case 0x16f4f:
			return ICB_Extend;
		case 0x16f8f ... 0x16f92:
			return ICB_Extend;
		case 0x16fe4:
			return ICB_Extend;
		case 0x16ff0 ... 0x16ff1:
			return ICB_Extend;
		case 0x1bc9d ... 0x1bc9e:
			return ICB_Extend;
		case 0x1cf00 ... 0x1cf2d:
			return ICB_Extend;
		case 0x1cf30 ... 0x1cf46:
			return ICB_Extend;
		case 0x1d165 ... 0x1d169:
			return ICB_Extend;
		case 0x1d16d ... 0x1d172:
			return ICB_Extend;
		case 0x1d17b ... 0x1d182:
			return ICB_Extend;
		case 0x1d185 ... 0x1d18b:
			return ICB_Extend;
		case 0x1d1aa ... 0x1d1ad:
			return ICB_Extend;
		case 0x1d242 ... 0x1d244:
			return ICB_Extend;
		case 0x1da00 ... 0x1da36:
			return ICB_Extend;
		case 0x1da3b ... 0x1da6c:
			return ICB_Extend;
		case 0x1da75:
			return ICB_Extend;
		case 0x1da84:
			return ICB_Extend;
		case 0x1da9b ... 0x1da9f:
			return ICB_Extend;
		case 0x1daa1 ... 0x1daaf:
			return ICB_Extend;
		case 0x1e000 ... 0x1e006:
			return ICB_Extend;
		case 0x1e008 ... 0x1e018:
			return ICB_Extend;
		case 0x1e01b ... 0x1e021:
			return ICB_Extend;
		case 0x1e023 ... 0x1e024:
			return ICB_Extend;
		case 0x1e026 ... 0x1e02a:
			return ICB_Extend;
		case 0x1e08f:
			return ICB_Extend;
		case 0x1e130 ... 0x1e136:
			return ICB_Extend;
		case 0x1e2ae:
			return ICB_Extend;
		case 0x1e2ec ... 0x1e2ef:
			return ICB_Extend;
		case 0x1e4ec ... 0x1e4ef:
			return ICB_Extend;
		case 0x1e5ee ... 0x1e5ef:
			return ICB_Extend;
		case 0x1e8d0 ... 0x1e8d6:
			return ICB_Extend;
		case 0x1e944 ... 0x1e94a:
			return ICB_Extend;
		case 0x1f3fb ... 0x1f3ff:
			return ICB_Extend;
		case 0xe0020 ... 0xe007f:
			return ICB_Extend;
		case 0xe0100 ... 0xe01ef:
			return ICB_Extend;
		 // }}}

	}
	return ICB_None;
}

static inline bool
is_extended_pictographic(char_type c) {
    switch (c) {
        default: return false;

		case 0xa9:
			return true;
		case 0xae:
			return true;
		case 0x203c:
			return true;
		case 0x2049:
			return true;
		case 0x2122:
			return true;
		case 0x2139:
			return true;
		case 0x2194 ... 0x2199:
			return true;
		case 0x21a9 ... 0x21aa:
			return true;
		case 0x231a ... 0x231b:
			return true;
		case 0x2328:
			return true;
		case 0x2388:
			return true;
		case 0x23cf:
			return true;
		case 0x23e9 ... 0x23f3:
			return true;
		case 0x23f8 ... 0x23fa:
			return true;
		case 0x24c2:
			return true;
		case 0x25aa ... 0x25ab:
			return true;
		case 0x25b6:
			return true;
		case 0x25c0:
			return true;
		case 0x25fb ... 0x25fe:
			return true;
		case 0x2600 ... 0x2605:
			return true;
		case 0x2607 ... 0x2612:
			return true;
		case 0x2614 ... 0x2685:
			return true;
		case 0x2690 ... 0x2705:
			return true;
		case 0x2708 ... 0x2712:
			return true;
		case 0x2714:
			return true;
		case 0x2716:
			return true;
		case 0x271d:
			return true;
		case 0x2721:
			return true;
		case 0x2728:
			return true;
		case 0x2733 ... 0x2734:
			return true;
		case 0x2744:
			return true;
		case 0x2747:
			return true;
		case 0x274c:
			return true;
		case 0x274e:
			return true;
		case 0x2753 ... 0x2755:
			return true;
		case 0x2757:
			return true;
		case 0x2763 ... 0x2767:
			return true;
		case 0x2795 ... 0x2797:
			return true;
		case 0x27a1:
			return true;
		case 0x27b0:
			return true;
		case 0x27bf:
			return true;
		case 0x2934 ... 0x2935:
			return true;
		case 0x2b05 ... 0x2b07:
			return true;
		case 0x2b1b ... 0x2b1c:
			return true;
		case 0x2b50:
			return true;
		case 0x2b55:
			return true;
		case 0x3030:
			return true;
		case 0x303d:
			return true;
		case 0x3297:
			return true;
		case 0x3299:
			return true;
		case 0x1f000 ... 0x1f0ff:
			return true;
		case 0x1f10d ... 0x1f10f:
			return true;
		case 0x1f12f:
			return true;
		case 0x1f16c ... 0x1f171:
			return true;
		case 0x1f17e ... 0x1f17f:
			return true;
		case 0x1f18e:
			return true;
		case 0x1f191 ... 0x1f19a:
			return true;
		case 0x1f1ad ... 0x1f1e5:
			return true;
		case 0x1f201 ... 0x1f20f:
			return true;
		case 0x1f21a:
			return true;
		case 0x1f22f:
			return true;
		case 0x1f232 ... 0x1f23a:
			return true;
		case 0x1f23c ... 0x1f23f:
			return true;
		case 0x1f249 ... 0x1f3fa:
			return true;
		case 0x1f400 ... 0x1f53d:
			return true;
		case 0x1f546 ... 0x1f64f:
			return true;
		case 0x1f680 ... 0x1f6ff:
			return true;
		case 0x1f774 ... 0x1f77f:
			return true;
		case 0x1f7d5 ... 0x1f7ff:
			return true;
		case 0x1f80c ... 0x1f80f:
			return true;
		case 0x1f848 ... 0x1f84f:
			return true;
		case 0x1f85a ... 0x1f85f:
			return true;
		case 0x1f888 ... 0x1f88f:
			return true;
		case 0x1f8ae ... 0x1f8ff:
			return true;
		case 0x1f90c ... 0x1f93a:
			return true;
		case 0x1f93c ... 0x1f945:
			return true;
		case 0x1f947 ... 0x1faff:
			return true;
		case 0x1fc00 ... 0x1fffd:
			return true;

    }
}

END_ALLOW_CASE_RANGE
